# 0 "insque.c"
# 0 "<built-in>"
# 0 "<command-line>"
# 1 "insque.c"
/* Copyright (C) 1997 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1995 DJ Delorie, see COPYING.DJ for details */
# 1 "../../../../include/search.h" 1
/* Copyright (C) 2012 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2003 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1999 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1995 DJ Delorie, see COPYING.DJ for details */
# 14 "../../../../include/search.h"
# 1 "../../../../include/sys/djtypes.h" 1
/* Copyright (C) 2011 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2003 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2002 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2001 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2000 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1999 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1998 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1994 DJ Delorie, see COPYING.DJ for details */
# 23 "../../../../include/sys/djtypes.h"
/* For GCC 3.00 or later we use its builtin va_list.                       */
# 34 "../../../../include/sys/djtypes.h"
/* but remains a typedef in C */





/* Define internal type to be used for avoiding strict
   aliasing warnings */

typedef short __attribute__((__may_alias__)) __dj_short_a;
typedef int __attribute__((__may_alias__)) __dj_int_a;
typedef long __attribute__((__may_alias__)) __dj_long_a;
typedef long long __attribute__((__may_alias__)) __dj_long_long_a;
typedef unsigned short __attribute__((__may_alias__)) __dj_unsigned_short_a;
typedef unsigned int __attribute__((__may_alias__)) __dj_unsigned_int_a;
typedef unsigned long __attribute__((__may_alias__)) __dj_unsigned_long_a;
typedef unsigned long long __attribute__((__may_alias__)) __dj_unsigned_long_long_a;
typedef float __attribute__((__may_alias__)) __dj_float_a;
typedef double __attribute__((__may_alias__)) __dj_double_a;
typedef long double __attribute__((__may_alias__)) __dj_long_double_a;
# 15 "../../../../include/search.h" 2


typedef long unsigned int size_t;
# 28 "../../../../include/search.h"
/* ACTION type for hsearch(). */
typedef enum {
  FIND,
  ENTER
} ACTION;

/* ENTRY type for hsearch(). */
typedef struct entry {
  char *key;
  void *data;
} ENTRY;


int hcreate(size_t _nel);
void hdestroy(void);
ENTRY * hsearch(ENTRY _item, ACTION _action);
void * lfind(const void *_key, void *_base, size_t *_nelp, size_t _width,
       int(*_compar)(const void *, const void *));
void * lsearch(const void *_key, void *_base, size_t *_nelp, size_t _width,
  int(*_compar)(const void *, const void *));

typedef enum { preorder, postorder, endorder, leaf } VISIT;
void *tdelete(const void *, void **, int(*)(const void *, const void *));
void *tfind(const void *, void *const *, int(*)(const void *, const void *));
void *tsearch(const void *, void **, int (*)(const void *, const void *));
void twalk(const void *, void (*)(const void *, VISIT, int));



/* qelem type for insque and remque. */
typedef struct qelem {
  struct qelem *q_forw;
  struct qelem *q_back;
  char q_data[0];
} qelem;

unsigned long _hash2v(const unsigned char *s, unsigned long *v2);
void insque(struct qelem *_elem, struct qelem *_pred);
void remque(struct qelem *_elem);
# 4 "insque.c" 2

void
insque(struct qelem *e, struct qelem *p)
{
  if (!e || !p)
    return;
  e->q_back = p;
  e->q_forw = p->q_forw;
  if (p->q_forw)
    p->q_forw->q_back = e;
  p->q_forw = e;
}
