# 0 "regexec.c"
# 0 "<built-in>"
# 0 "<command-line>"
# 1 "regexec.c"
/* Copyright (C) 1998 DJ Delorie, see COPYING.DJ for details */
/*
 * the outer shell of regexec()
 *
 * This file includes engine.c *twice*, after muchos fiddling with the
 * macros that code uses.  This lets the same code operate on two different
 * representations for state sets.
 */
# 1 "../../../../include/sys/types.h" 1
/* Copyright (C) 2012 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2003 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2002 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2001 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2000 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1999 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1997 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1995 DJ Delorie, see COPYING.DJ for details */
# 25 "../../../../include/sys/types.h"
# 1 "../../../../include/sys/djtypes.h" 1
/* Copyright (C) 2011 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2003 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2002 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2001 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2000 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1999 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1998 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1994 DJ Delorie, see COPYING.DJ for details */
# 23 "../../../../include/sys/djtypes.h"
/* For GCC 3.00 or later we use its builtin va_list.                       */
# 34 "../../../../include/sys/djtypes.h"
/* but remains a typedef in C */





/* Define internal type to be used for avoiding strict
   aliasing warnings */

typedef short __attribute__((__may_alias__)) __dj_short_a;
typedef int __attribute__((__may_alias__)) __dj_int_a;
typedef long __attribute__((__may_alias__)) __dj_long_a;
typedef long long __attribute__((__may_alias__)) __dj_long_long_a;
typedef unsigned short __attribute__((__may_alias__)) __dj_unsigned_short_a;
typedef unsigned int __attribute__((__may_alias__)) __dj_unsigned_int_a;
typedef unsigned long __attribute__((__may_alias__)) __dj_unsigned_long_a;
typedef unsigned long long __attribute__((__may_alias__)) __dj_unsigned_long_long_a;
typedef float __attribute__((__may_alias__)) __dj_float_a;
typedef double __attribute__((__may_alias__)) __dj_double_a;
typedef long double __attribute__((__may_alias__)) __dj_long_double_a;
# 26 "../../../../include/sys/types.h" 2

typedef int blkcnt_t;
typedef int blksize_t;
typedef int dev_t;
typedef unsigned long fsblkcnt_t;
typedef unsigned long fsfilcnt_t;
typedef int ino_t;
typedef int mode_t;
typedef int nlink_t;


typedef int gid_t;



typedef int off_t;



__extension__ typedef long long off64_t;



__extension__ typedef long long offset_t;



typedef int pid_t;



typedef long unsigned int size_t;



typedef long signed int ssize_t;




typedef int uid_t;




/* Allow including program to override.  */




typedef struct fd_set {
  unsigned char fd_bits [((256) + 7) / 8];
} fd_set;







typedef unsigned int time_t;
# 10 "regexec.c" 2
# 1 "../../../../include/stdio.h" 1
/* Copyright (C) 2018 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2017 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2014 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2013 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2003 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2002 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2001 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2000 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1998 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1995 DJ Delorie, see COPYING.DJ for details */
# 21 "../../../../include/stdio.h"
# 1 "../../../../include/sys/djtypes.h" 1
/* Copyright (C) 2011 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2003 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2002 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2001 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2000 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1999 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1998 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1994 DJ Delorie, see COPYING.DJ for details */
# 22 "../../../../include/stdio.h" 2





/* Some programs think they know better... */
# 49 "../../../../include/stdio.h"
typedef __builtin_va_list va_list;
# 63 "../../../../include/stdio.h"
/* Note that the definitions of these fields are NOT guaranteed!  They
   may change with any release without notice!  The fact that they
   are here at all is to comply with ANSI specifictions. */

typedef struct {
  ssize_t _cnt;
  char *_ptr;
  char *_base;
  size_t _bufsiz;
  int _flag;
  int _file;
  char *_name_to_remove;
  size_t _fillsize;
} FILE;

typedef unsigned long fpos_t;

extern FILE __dj_stdin, __dj_stdout, __dj_stderr;




void clearerr(FILE *_stream);
int fclose(FILE *_stream);
int feof(FILE *_stream);
int ferror(FILE *_stream);
int fflush(FILE *_stream);
int fgetc(FILE *_stream);
int fgetpos(FILE *_stream, fpos_t *_pos);
char * fgets(char *_s, int _n, FILE *_stream);
FILE * fopen(const char *_filename, const char *_mode);
int fprintf(FILE *_stream, const char *_format, ...);
int fputc(int _c, FILE *_stream);
int fputs(const char *_s, FILE *_stream);
size_t fread(void *_ptr, size_t _size, size_t _nelem, FILE *_stream);
FILE * freopen(const char *_filename, const char *_mode, FILE *_stream);
int fscanf(FILE *_stream, const char *_format, ...);
int fseek(FILE *_stream, long _offset, int _mode);
int fsetpos(FILE *_stream, const fpos_t *_pos);
long ftell(FILE *_stream);
size_t fwrite(const void *_ptr, size_t _size, size_t _nelem, FILE *_stream);
int getc(FILE *_stream);
int getchar(void);
char * gets(char *_s);
void perror(const char *_s);
int printf(const char *_format, ...);
int putc(int _c, FILE *_stream);
int putchar(int _c);
int puts(const char *_s);
int remove(const char *_filename);
int rename(const char *_old, const char *_new);
void rewind(FILE *_stream);
int scanf(const char *_format, ...);
void setbuf(FILE *_stream, char *_buf);
int setvbuf(FILE *_stream, char *_buf, int _mode, size_t _size);
int sprintf(char *_s, const char *_format, ...);
int sscanf(const char *_s, const char *_format, ...);
FILE * tmpfile(void);
char * tmpnam(char *_s);
int ungetc(int _c, FILE *_stream);
int vfprintf(FILE *_stream, const char *_format, va_list _ap);
int vprintf(const char *_format, va_list _ap);
int vsprintf(char *_s, const char *_format, va_list _ap);




int snprintf(char *str, size_t n, const char *fmt, ...);
int vfscanf(FILE *_stream, const char *_format, va_list _ap);
int vscanf(const char *_format, va_list _ap);
int vsnprintf(char *str, size_t n, const char *fmt, va_list ap);
int vsscanf(const char *_s, const char *_format, va_list _ap);







/* #define STREAM_MAX	20 - DOS can change this */

int dprintf(int _fd, const char *_format, ...) __attribute__ ((__format__ (__printf__, 2, 3)));
int fileno(FILE *_stream);
FILE * fdopen(int _fildes, const char *_type);
int mkstemp(char *_template);
int pclose(FILE *_pf);
FILE * popen(const char *_command, const char *_mode);
char * tempnam(const char *_dir, const char *_prefix);
int vdprintf(int _fd, const char *_format, va_list _ap) __attribute__ ((__format__ (__printf__, 2, 0)));



extern FILE __dj_stdprn, __dj_stdaux;





void _djstat_describe_lossage(FILE *_to_where);
int _doprnt(const char *_fmt, va_list _args, FILE *_f);
int _doscan(FILE *_f, const char *_fmt, va_list _args);
int _doscan_low(FILE *, int (*)(FILE *_get), int (*_unget)(int, FILE *), const char *_fmt, va_list _args);
int fpurge(FILE *_f);
int getw(FILE *_f);
char * mktemp(char *_template);
int putw(int _v, FILE *_f);
void setbuffer(FILE *_f, void *_buf, int _size);
void setlinebuf(FILE *_f);
int _rename(const char *_old, const char *_new); /* Simple (no directory) */
int asprintf(char **_sp, const char *_format, ...) __attribute__((format (__printf__, 2, 3)));
char * asnprintf(char *_s, size_t *_np, const char *_format, ...) __attribute__((format (__printf__, 3, 4)));
int vasprintf(char **_sp, const char *_format, va_list _ap) __attribute__((format (__printf__, 2, 0)));
char * vasnprintf(char *_s, size_t *_np, const char *_format, va_list _ap) __attribute__((format (__printf__, 3, 0)));
# 185 "../../../../include/stdio.h"
int fseeko(FILE *_stream, off_t _offset, int _mode);
off_t ftello(FILE *_stream);
int fseeko64(FILE *_stream, off64_t _offset, int _mode);
off64_t ftello64(FILE *_stream);
# 11 "regexec.c" 2
# 1 "../../../../include/stdlib.h" 1
/* Copyright (C) 2015 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2014 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2013 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2003 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2002 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2001 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2000 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1999 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1998 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1995 DJ Delorie, see COPYING.DJ for details */
# 20 "../../../../include/stdlib.h"
# 1 "../../../../include/sys/types.h" 1
/* Copyright (C) 2012 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2003 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2002 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2001 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2000 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1999 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1997 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1995 DJ Delorie, see COPYING.DJ for details */
# 21 "../../../../include/stdlib.h" 2
# 1 "../../../../include/stddef.h" 1
/* Copyright (C) 2012 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2003 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2001 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2000 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1994 DJ Delorie, see COPYING.DJ for details */
# 14 "../../../../include/stddef.h"
# 1 "../../../../include/sys/djtypes.h" 1
/* Copyright (C) 2011 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2003 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2002 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2001 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2000 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1999 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1998 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1994 DJ Delorie, see COPYING.DJ for details */
# 15 "../../../../include/stddef.h" 2

/* Some programs think they know better... */
# 26 "../../../../include/stddef.h"
//#ifdef __cplusplus
//#define offsetof(s_type, mbr) ((std::size_t) &((s_type *)0)->mbr)
//#else

//#endif


typedef int ptrdiff_t;
# 43 "../../../../include/stddef.h"
typedef unsigned short wchar_t;
# 22 "../../../../include/stdlib.h" 2

/* Some programs think they know better... */
# 38 "../../../../include/stdlib.h"
extern int __dj_mb_cur_max;

typedef struct {
  int quot;
  int rem;
} div_t;

typedef struct {
  long quot;
  long rem;
} ldiv_t;





void abort(void);
int abs(int _i);

int __dj_atexit(void (*_func)(void));
double atof(const char *_s);
int atoi(const char *_s);
long atol(const char *_s);
void * bsearch(const void *_key, const void *_base, size_t _nelem,
  size_t _size, int (*_cmp)(const void *_ck, const void *_ce));
void * calloc(size_t _nelem, size_t _size);
unsigned int calloc32(size_t _nelem, size_t _size);
div_t div(int _numer, int _denom);
void exit(int _status);
void free(void *_ptr);
void free32(unsigned int _addr);
char * getenv(const char *_name);
long labs(long _i);
ldiv_t ldiv(long _numer, long _denom);
void * malloc(size_t _size);
unsigned int malloc32(size_t _size);
int mblen(const char *_s, size_t _n);
size_t mbstowcs(wchar_t *_wcs, const char *_s, size_t _n);
int mbtowc(wchar_t *_pwc, const char *_s, size_t _n);
void qsort(void *_base, size_t _nelem, size_t _size,
       int (*_cmp)(const void *_e1, const void *_e2));
int rand(void);
void * realloc(void *_ptr, size_t _size);
unsigned int realloc32(unsigned int _addr, size_t _size);
void srand(unsigned _seed);
double strtod(const char *_s, char **_endptr);
long strtol(const char *_s, char **_endptr, int _base);
unsigned long strtoul(const char *_s, char **_endptr, int _base);
int system(const char *_s);
size_t wcstombs(char *_s, const wchar_t *_wcs, size_t _n);
int wctomb(char *_s, wchar_t _wchar);




typedef struct {
  long long int quot;
  long long int rem;
} lldiv_t;

void _Exit(int _status);
long long int atoll(const char *_s);
long long int llabs(long long int _i);
lldiv_t lldiv(long long int _numer, long long int _denom);
float strtof(const char *_s, char **_endptr);
long double strtold(const char *_s, char **_endptr);
long long int strtoll(const char *_s, char **_endptr, int _base);
unsigned long long int strtoull(const char *_s, char **_endptr, int _base);





long a64l(const char *_string);
char * l64a(long _value);
char * mktemp(char *_template);
char * mkdtemp(char *_template);
int mkstemp(char *_template);
int putenv(char *_val);
char * realpath(const char *_path, char *_resolved);
int setenv(const char *_var, const char *_val, int _overwrite);
int unsetenv(const char *_var);



void * alloca(size_t _size);
long double _atold(const char *_s);
void cfree(void *_ptr);
double drand48(void);
char * ecvtbuf(double _val, int _nd, int *_dp, int *_sn, char *_bf);
char * ecvt(double _val, int _nd, int *_dp, int *_sn);
double erand48(unsigned short _state[3]);
char * fcvtbuf(double _val, int _nd, int *_dp, int *_sn, char *_bf);
char * fcvt(double _val, int _nd, int *_dp, int *_sn);
char * gcvt(double _val, int _nd, char *_buf);
char * getpass(const char *_prompt);
int getlongpass(const char *_prompt, char *_buffer, int _max_len);
char * itoa(int _value, char *_buffer, int _radix);
long jrand48(unsigned short _state[3]);
void lcong48(unsigned short _param[7]);
unsigned long lrand48(void);
long mrand48(void);
unsigned long nrand48(unsigned short _state[3]);
unsigned short *seed48(unsigned short _state_seed[3]);
void srand48(long _seedval);
long double _strtold(const char *_s, char **_endptr);
void swab(const void *_from, void *_to, ssize_t _nbytes);
void * valloc (size_t _amt);





/* BSD Random Number Generator */
char * initstate (unsigned _seed, char *_arg_state, int _n);
char * setstate(char *_arg_state);
long random(void);
int srandom(int _seed);

/* These vary in expected prototype, so we just don't prototype them.
void		xfree(void *_ptr);
void *		xmalloc(size_t _size);
void *		xrealloc(void *ptr, size_t _size);
*/
# 173 "../../../../include/stdlib.h"
extern int __system_flags;
# 12 "regexec.c" 2
# 1 "../../../../include/string.h" 1
/* Copyright (C) 2017 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2013 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2003 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2002 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2000 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1998 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1995 DJ Delorie, see COPYING.DJ for details */
# 17 "../../../../include/string.h"
# 1 "../../../../include/sys/djtypes.h" 1
/* Copyright (C) 2011 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2003 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2002 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2001 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2000 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1999 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1998 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1994 DJ Delorie, see COPYING.DJ for details */
# 18 "../../../../include/string.h" 2

/* Some programs think they know better... */
# 34 "../../../../include/string.h"
void * memchr(const void *_s, int _c, size_t _n);
int memcmp(const void *_s1, const void *_s2, size_t _n);
void * memcpy(void * _dest, const void * _src, size_t _n);
void * memmove(void *_s1, const void *_s2, size_t _n);
void * memset(void *_s, int _c, size_t _n);
char * strcat(char * _s1, const char * _s2);
char * strchr(const char *_s, int _c);
int strcmp(const char *_s1, const char *_s2);
int strcoll(const char *_s1, const char *_s2);
char * strcpy(char * _s1, const char * _s2);
size_t strcspn(const char *_s1, const char *_s2);
char * strerror(int _errcode);
size_t strlen(const char *_s);
char * strncat(char * _s1, const char * _s2, size_t _n);
int strncmp(const char *_s1, const char *_s2, size_t _n);
char * strncpy(char * _s1, const char * _s2, size_t _n);
char * strpbrk(const char *_s1, const char *_s2);
char * strrchr(const char *_s, int _c);
size_t strspn(const char *_s1, const char *_s2);
char * strstr(const char *_s1, const char *_s2);
char * strtok(char * _s1, const char * _s2);
size_t strxfrm(char * _s1, const char * _s2, size_t _n);
# 64 "../../../../include/string.h"
int strerror_r(int _errnum, char *_strerrbuf, size_t _buflen);
char * strtok_r(char * _s1, const char * _s2, char ** _s3);



# 1 "../../../../include/sys/movedata.h" 1
/* Copyright (C) 2012 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2003 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2000 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1998 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1995 DJ Delorie, see COPYING.DJ for details */
# 24 "../../../../include/sys/movedata.h"
# 1 "../../../../include/sys/djtypes.h" 1
/* Copyright (C) 2011 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2003 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2002 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2001 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2000 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1999 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1998 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1994 DJ Delorie, see COPYING.DJ for details */
# 25 "../../../../include/sys/movedata.h" 2
# 1 "../../../../include/stdint.h" 1
/* Copyright (C) 2015 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2014 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2013 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2003 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2002 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2001 DJ Delorie, see COPYING.DJ for details */
# 17 "../../../../include/stdint.h"
typedef signed char int_least8_t;
typedef unsigned char uint_least8_t;
typedef signed char int_fast8_t;
typedef unsigned char uint_fast8_t;
typedef signed char int8_t;
typedef unsigned char uint8_t;

typedef signed short int int_least16_t;
typedef unsigned short int uint_least16_t;
typedef signed int int_fast16_t;
typedef unsigned int uint_fast16_t;
typedef signed short int int16_t;
typedef unsigned short int uint16_t;

typedef signed int int_least32_t;
typedef unsigned int uint_least32_t;
typedef signed int int_fast32_t;
typedef unsigned int uint_fast32_t;
typedef signed int int32_t;
typedef unsigned int uint32_t;

__extension__ typedef signed long long int int_least64_t;
__extension__ typedef unsigned long long int uint_least64_t;
__extension__ typedef signed long long int int_fast64_t;
__extension__ typedef unsigned long long int uint_fast64_t;
__extension__ typedef signed long long int int64_t;
__extension__ typedef unsigned long long int uint64_t;

typedef long int intptr_t;
typedef unsigned long int uintptr_t;

__extension__ typedef signed long long int intmax_t;
__extension__ typedef unsigned long long int uintmax_t;

/* ANSI/ISO C99 says these should not be visible in C++ unless
   explicitly requested.  */

//#if !defined(__cplusplus) || defined(__STDC_LIMIT_MACROS)
# 110 "../../../../include/stdint.h"
  /* These are defined by limits.h, so make them conditional.  */
# 124 "../../../../include/stdint.h"
//#endif /* !__cplusplus || __STDC_LIMIT_MACROS */
# 26 "../../../../include/sys/movedata.h" 2

# 1 "../../../../include/sys/fmemcpy.h" 1



# 1 "../../../../include/dpmi.h" 1
/* Copyright (C) 2012 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2003 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1999 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1995 DJ Delorie, see COPYING.DJ for details */



# 1 "../../../../include/sys/cdefs.h" 1
/* Copyright (C) 2011 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2003 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1998 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1994 DJ Delorie, see COPYING.DJ for details */
# 40 "../../../../include/sys/cdefs.h"
/* Support gcc's __attribute__ facility.  */




/* Ensure that always traditional GNU extern inline semantics are used
   (aka -fgnu89-inline) even if ISO C99 semantics have been specified.  */
# 9 "../../../../include/dpmi.h" 2
# 1 "../../../../include/sys/nearptr.h" 1
/* Copyright (C) 2012 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2003 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1995 DJ Delorie, see COPYING.DJ for details */



# 1 "../../../../include/libc/asmobj.h" 1
/*
 *  dj64 - 64bit djgpp-compatible tool-chain
 *  Copyright (C) 2021-2024  @stsp
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

# 1 "../../../../include/libc/djthunks.h" 1
/*
 *  dj64 - 64bit djgpp-compatible tool-chain
 *  Copyright (C) 2021-2024  @stsp
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */




# 1 "../../../../include/stdint.h" 1
/* Copyright (C) 2015 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2014 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2013 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2003 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2002 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2001 DJ Delorie, see COPYING.DJ for details */
# 23 "../../../../include/libc/djthunks.h" 2

void crt1_startup(int handle);

uint8_t *djaddr2ptr(uint32_t addr);
uint8_t *djaddr2ptr2(uint32_t addr, uint32_t len);
uint32_t djptr2addr(const uint8_t *ptr);
uint32_t djthunk_get(const char *name);
uint32_t djthunk_get_h(int handle, const char *name);
void *djsbrk(int increment);
# 20 "../../../../include/libc/asmobj.h" 2
# 8 "../../../../include/sys/nearptr.h" 2
# 24 "../../../../include/sys/nearptr.h"
/* Functions to enable "near" pointer access to DOS memory under DPMI
   CW Sandmann 7-95  NO WARRANTY: WARNING, since these functions disable
   memory protection, they MAY DESTROY EVERYTHING ON YOUR COMPUTER! */

int __djgpp_nearptr_enable(void); /* Returns 0 if feature not avail */
void __djgpp_nearptr_disable(void); /* Enables protection */
extern int *____djgpp_selector_limit(void);/*
*/
# 30 "../../../../include/sys/nearptr.h"
       #define __djgpp_selector_limit (*____djgpp_selector_limit())/*
*/
# 30 "../../../../include/sys/nearptr.h"
                                       ; /* Limit on CS and on DS if prot */
extern unsigned *____djgpp_base_address(void);/*
*/
# 31 "../../../../include/sys/nearptr.h"
       #define __djgpp_base_address (*____djgpp_base_address())/*
*/
# 31 "../../../../include/sys/nearptr.h"
                                          ; /* Used in calculation below */
# 10 "../../../../include/dpmi.h" 2
# 1 "../../../../include/libc/asmobj.h" 1
/*
 *  dj64 - 64bit djgpp-compatible tool-chain
 *  Copyright (C) 2021-2024  @stsp
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

# 1 "../../../../include/libc/djthunks.h" 1
/*
 *  dj64 - 64bit djgpp-compatible tool-chain
 *  Copyright (C) 2021-2024  @stsp
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
# 20 "../../../../include/libc/asmobj.h" 2
# 11 "../../../../include/dpmi.h" 2
# 1 "../../../../include/stdint.h" 1
/* Copyright (C) 2015 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2014 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2013 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2003 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2002 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2001 DJ Delorie, see COPYING.DJ for details */
# 12 "../../../../include/dpmi.h" 2
# 26 "../../../../include/dpmi.h"
//#ifndef _POSIX_SOURCE

extern unsigned short *____dpmi_error(void);/*
*/
# 28 "../../../../include/dpmi.h"
       #define __dpmi_error (*____dpmi_error())/*
*/
# 28 "../../../../include/dpmi.h"
                                        ;

typedef struct {
  unsigned short offset16;
  unsigned short segment;
} __dpmi_raddr;

typedef struct {
  unsigned int offset32;
  unsigned short selector;
} __dpmi_paddr;

typedef struct {
  unsigned int handle; /* 0, 2 */
  unsigned int size; /* or count */ /* 4, 6 */
  unsigned int address; /* 8, 10 */
} __dpmi_meminfo;

typedef union {
  struct {
    unsigned int edi;
    unsigned int esi;
    unsigned int ebp;
    unsigned int res;
    unsigned int ebx;
    unsigned int edx;
    unsigned int ecx;
    unsigned int eax;
  } d;
  struct {
    unsigned short di, di_hi;
    unsigned short si, si_hi;
    unsigned short bp, bp_hi;
    unsigned short res, res_hi;
    unsigned short bx, bx_hi;
    unsigned short dx, dx_hi;
    unsigned short cx, cx_hi;
    unsigned short ax, ax_hi;
    unsigned short flags;
    unsigned short es;
    unsigned short ds;
    unsigned short fs;
    unsigned short gs;
    unsigned short ip;
    unsigned short cs;
    unsigned short sp;
    unsigned short ss;
  } x;
  struct {
    unsigned char edi[4];
    unsigned char esi[4];
    unsigned char ebp[4];
    unsigned char res[4];
    unsigned char bl, bh, ebx_b2, ebx_b3;
    unsigned char dl, dh, edx_b2, edx_b3;
    unsigned char cl, ch, ecx_b2, ecx_b3;
    unsigned char al, ah, eax_b2, eax_b3;
  } h;
} __attribute__((packed)) __dpmi_regs;

typedef struct {
  unsigned char major;
  unsigned char minor;
  unsigned short flags;
  unsigned char cpu;
  unsigned char master_pic;
  unsigned char slave_pic;
} __dpmi_version_ret;

typedef struct {
  unsigned int largest_available_free_block_in_bytes;
  unsigned int maximum_unlocked_page_allocation_in_pages;
  unsigned int maximum_locked_page_allocation_in_pages;
  unsigned int linear_address_space_size_in_pages;
  unsigned int total_number_of_unlocked_pages;
  unsigned int total_number_of_free_pages;
  unsigned int total_number_of_physical_pages;
  unsigned int free_linear_address_space_in_pages;
  unsigned int size_of_paging_file_partition_in_pages;
  unsigned int reserved[3];
} __dpmi_free_mem_info;

typedef struct {
  unsigned int total_allocated_bytes_of_physical_memory_host;
  unsigned int total_allocated_bytes_of_virtual_memory_host;
  unsigned int total_available_bytes_of_virtual_memory_host;
  unsigned int total_allocated_bytes_of_virtual_memory_vcpu;
  unsigned int total_available_bytes_of_virtual_memory_vcpu;
  unsigned int total_allocated_bytes_of_virtual_memory_client;
  unsigned int total_available_bytes_of_virtual_memory_client;
  unsigned int total_locked_bytes_of_memory_client;
  unsigned int max_locked_bytes_of_memory_client;
  unsigned int highest_linear_address_available_to_client;
  unsigned int size_in_bytes_of_largest_free_memory_block;
  unsigned int size_of_minimum_allocation_unit_in_bytes;
  unsigned int size_of_allocation_alignment_unit_in_bytes;
  unsigned int reserved[19];
} __dpmi_memory_info;

typedef struct {
  unsigned int data16[2];
  unsigned int code16[2];
  unsigned short ip;
  unsigned short reserved;
  unsigned int data32[2];
  unsigned int code32[2];
  unsigned int eip;
} __dpmi_callback_info;

typedef struct {
  unsigned int size_requested;
  unsigned int size;
  unsigned int handle;
  unsigned int address;
  unsigned int name_offset;
  unsigned short name_selector;
  unsigned short reserved1;
  unsigned int reserved2;
} __dpmi_shminfo;

/* Unless otherwise noted, all functions return -1 on error, setting __dpmi_error to the DPMI error code */

void __dpmi_yield(void); /* INT 0x2F AX=1680 */

int __dpmi_allocate_ldt_descriptors(int _count); /* DPMI 0.9 AX=0000 */
int __dpmi_free_ldt_descriptor(int _descriptor); /* DPMI 0.9 AX=0001 */
int __dpmi_segment_to_descriptor(int _segment); /* DPMI 0.9 AX=0002 */
int __dpmi_get_selector_increment_value(void); /* DPMI 0.9 AX=0003 */
int __dpmi_get_segment_base_address(int _selector, unsigned int *_addr); /* DPMI 0.9 AX=0006 */
int __dpmi_set_segment_base_address(int _selector, unsigned int _address); /* DPMI 0.9 AX=0007 */
unsigned int __dpmi_get_segment_limit(int _selector); /* LSL instruction  */
int __dpmi_set_segment_limit(int _selector, unsigned int _limit); /* DPMI 0.9 AX=0008 */
int __dpmi_get_descriptor_access_rights(int _selector); /* LAR instruction  */
int __dpmi_set_descriptor_access_rights(int _selector, int _rights); /* DPMI 0.9 AX=0009 */
int __dpmi_create_alias_descriptor(int _selector); /* DPMI 0.9 AX=000a */
int __dpmi_get_descriptor(int _selector, unsigned char _buffer[8]); /* DPMI 0.9 AX=000b */
int __dpmi_set_descriptor(int _selector, unsigned char _buffer[8]); /* DPMI 0.9 AX=000c */
int __dpmi_allocate_specific_ldt_descriptor(int _selector); /* DPMI 0.9 AX=000d */


int __dpmi_get_multiple_descriptors(int _count, void *_buffer); /* DPMI 1.0 AX=000e */
int __dpmi_set_multiple_descriptors(int _count, void *_buffer); /* DPMI 1.0 AX=000f */

int __dpmi_allocate_dos_memory(int _paragraphs, int *_ret_selector_or_max); /* DPMI 0.9 AX=0100 */
int __dpmi_free_dos_memory(int _selector); /* DPMI 0.9 AX=0101 */
int __dpmi_resize_dos_memory(int _selector, int _newpara, int *_ret_max); /* DPMI 0.9 AX=0102 */

int __dpmi_get_real_mode_interrupt_vector(int _vector, __dpmi_raddr *_address); /* DPMI 0.9 AX=0200 */
int __dpmi_set_real_mode_interrupt_vector(int _vector, __dpmi_raddr *_address); /* DPMI 0.9 AX=0201 */
int __dpmi_get_processor_exception_handler_vector(int _vector, __dpmi_paddr *_address); /* DPMI 0.9 AX=0202 */
int __dpmi_set_processor_exception_handler_vector(int _vector, __dpmi_paddr *_address); /* DPMI 0.9 AX=0203 */
int __dpmi_get_protected_mode_interrupt_vector(int _vector, __dpmi_paddr *_address); /* DPMI 0.9 AX=0204 */
int __dpmi_set_protected_mode_interrupt_vector(int _vector, __dpmi_paddr *_address); /* DPMI 0.9 AX=0205 */

int __dpmi_get_extended_exception_handler_vector_pm(int _vector, __dpmi_paddr *_address); /* DPMI 1.0 AX=0210 */
int __dpmi_get_extended_exception_handler_vector_rm(int _vector, __dpmi_paddr *_address); /* DPMI 1.0 AX=0211 */
int __dpmi_set_extended_exception_handler_vector_pm(int _vector, __dpmi_paddr *_address); /* DPMI 1.0 AX=0212 */
int __dpmi_set_extended_exception_handler_vector_rm(int _vector, __dpmi_paddr *_address); /* DPMI 1.0 AX=0213 */

int __dpmi_simulate_real_mode_interrupt(int _vector, __dpmi_regs *_regs); /* DPMI 0.9 AX=0300 */
int __dpmi_int(int _vector, __dpmi_regs *_regs); /* like above, but sets ss sp fl */ /* DPMI 0.9 AX=0300 */
extern short __dpmi_int_ss, __dpmi_int_sp, __dpmi_int_flags; /* default to zero */
int __dpmi_simulate_real_mode_procedure_retf(__dpmi_regs *_regs); /* DPMI 0.9 AX=0301 */
int __dpmi_simulate_real_mode_procedure_retf_stack(__dpmi_regs *_regs, int stack_words_to_copy, const void *stack_data); /* DPMI 0.9 AX=0301 */
int __dpmi_simulate_real_mode_procedure_iret(__dpmi_regs *_regs); /* DPMI 0.9 AX=0302 */
int __dpmi_allocate_real_mode_callback(unsigned int _handler, unsigned int _regs, __dpmi_raddr *_ret); /* DPMI 0.9 AX=0303 */
int __dpmi_free_real_mode_callback(__dpmi_raddr *_addr); /* DPMI 0.9 AX=0304 */
int __dpmi_get_state_save_restore_addr( __dpmi_raddr *_rm, __dpmi_paddr *_pm); /* DPMI 0.9 AX=0305 */
int __dpmi_get_raw_mode_switch_addr( __dpmi_raddr *_rm, __dpmi_paddr *_pm); /* DPMI 0.9 AX=0306 */

int __dpmi_get_version( __dpmi_version_ret *_ret); /* DPMI 0.9 AX=0400 */

int __dpmi_get_capabilities( int *_flags, char vendor_info[128]); /* DPMI 1.0 AX=0401 */

int __dpmi_get_free_memory_information( __dpmi_free_mem_info *_info); /* DPMI 0.9 AX=0500 */
int __dpmi_allocate_memory(__dpmi_meminfo *_info); /* DPMI 0.9 AX=0501 */
int __dpmi_free_memory(unsigned int _handle); /* DPMI 0.9 AX=0502 */
int __dpmi_resize_memory(__dpmi_meminfo *_info); /* DPMI 0.9 AX=0503 */

int __dpmi_allocate_linear_memory(__dpmi_meminfo *_info, int _commit); /* DPMI 1.0 AX=0504 */
int __dpmi_resize_linear_memory(__dpmi_meminfo *_info, int _commit); /* DPMI 1.0 AX=0505 */
int __dpmi_get_page_attributes(__dpmi_meminfo *_info, short *_buffer); /* DPMI 1.0 AX=0506 */
int __dpmi_set_page_attributes(__dpmi_meminfo *_info, short *_buffer); /* DPMI 1.0 AX=0507 */
int __dpmi_map_device_in_memory_block(__dpmi_meminfo *_info, unsigned int _physaddr); /* DPMI 1.0 AX=0508 */
int __dpmi_map_conventional_memory_in_memory_block(__dpmi_meminfo *_info, unsigned int _linaddr); /* DPMI 1.0 AX=0509 */
int __dpmi_get_memory_block_size_and_base(__dpmi_meminfo *_info); /* DPMI 1.0 AX=050a */
int __dpmi_get_memory_information( __dpmi_memory_info *_buffer); /* DPMI 1.0 AX=050b */

int __dpmi_lock_linear_region(__dpmi_meminfo *_info); /* DPMI 0.9 AX=0600 */
int __dpmi_unlock_linear_region(__dpmi_meminfo *_info); /* DPMI 0.9 AX=0601 */
int __dpmi_mark_real_mode_region_as_pageable(__dpmi_meminfo *_info); /* DPMI 0.9 AX=0602 */
int __dpmi_relock_real_mode_region(__dpmi_meminfo *_info); /* DPMI 0.9 AX=0603 */
int __dpmi_get_page_size( unsigned int *_size); /* DPMI 0.9 AX=0604 */

int __dpmi_mark_page_as_demand_paging_candidate(__dpmi_meminfo *_info); /* DPMI 0.9 AX=0702 */
int __dpmi_discard_page_contents(__dpmi_meminfo *_info); /* DPMI 0.9 AX=0703 */

int __dpmi_physical_address_mapping(__dpmi_meminfo *_info); /* DPMI 0.9 AX=0800 */
int __dpmi_free_physical_address_mapping(__dpmi_meminfo *_info); /* DPMI 0.9 AX=0801 */

/* These next four functions return the old state */
int __dpmi_get_and_disable_virtual_interrupt_state(void); /* DPMI 0.9 AX=0900 */
int __dpmi_get_and_enable_virtual_interrupt_state(void); /* DPMI 0.9 AX=0901 */
int __dpmi_get_and_set_virtual_interrupt_state(int _old_state); /* DPMI 0.9 AH=09   */
int __dpmi_get_virtual_interrupt_state(void); /* DPMI 0.9 AX=0902 */

int __dpmi_get_vendor_specific_api_entry_point(const char *_id, __dpmi_paddr *_api); /* DPMI 0.9 AX=0a00 */

int __dpmi_set_debug_watchpoint(__dpmi_meminfo *_info, int _type); /* DPMI 0.9 AX=0b00 */
int __dpmi_clear_debug_watchpoint(unsigned int _handle); /* DPMI 0.9 AX=0b01 */
int __dpmi_get_state_of_debug_watchpoint(unsigned int _handle, int *_status); /* DPMI 0.9 AX=0b02 */
int __dpmi_reset_debug_watchpoint(unsigned int _handle); /* DPMI 0.9 AX=0b03 */

int __dpmi_install_resident_service_provider_callback(__dpmi_callback_info *_info); /* DPMI 1.0 AX=0c00 */
int __dpmi_terminate_and_stay_resident(int return_code, int paragraphs_to_keep); /* DPMI 1.0 AX=0c01 */

int __dpmi_allocate_shared_memory(__dpmi_shminfo *_info); /* DPMI 1.0 AX=0d00 */
int __dpmi_free_shared_memory(unsigned int _handle); /* DPMI 1.0 AX=0d01 */
int __dpmi_serialize_on_shared_memory(unsigned int _handle, int _flags); /* DPMI 1.0 AX=0d02 */
int __dpmi_free_serialization_on_shared_memory(unsigned int _handle, int _flags); /* DPMI 1.0 AX=0d03 */

int __dpmi_get_coprocessor_status(void); /* DPMI 1.0 AX=0e00 */
int __dpmi_set_coprocessor_emulation(int _flags); /* DPMI 1.0 AX=0e01 */

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* Backwards compatibility stuff						       */



typedef struct {
  unsigned int available_memory;
  unsigned int available_pages;
  unsigned int available_lockable_pages;
  unsigned int linear_space;
  unsigned int unlocked_pages;
  unsigned int available_physical_pages;
  unsigned int total_physical_pages;
  unsigned int free_linear_space;
  unsigned int max_pages_in_paging_file;
  unsigned int reserved[3];
} _go32_dpmi_meminfo;







typedef struct {
  unsigned int size;
  unsigned int pm_offset;
  unsigned short pm_selector;
  unsigned short rm_offset;
  unsigned short rm_segment;
} _go32_dpmi_seginfo;

/* returns zero if success, else dpmi error and info->size is max size */
int _go32_dpmi_allocate_dos_memory(_go32_dpmi_seginfo *info);
 /* set size to bytes/16, call, use rm_segment.  Do not
	   change anthing but size until the memory is freed.
	   If error, max size is returned in size as bytes/16. */
int _go32_dpmi_free_dos_memory(_go32_dpmi_seginfo *info);
 /* set new size to bytes/16, call.  If error, max size
	   is returned in size as bytes/16 */
int _go32_dpmi_resize_dos_memory(_go32_dpmi_seginfo *info);
 /* uses pm_selector to free memory */

/* These both use the rm_segment:rm_offset fields only */
int _go32_dpmi_get_real_mode_interrupt_vector(int vector, _go32_dpmi_seginfo *info);
int _go32_dpmi_set_real_mode_interrupt_vector(int vector, _go32_dpmi_seginfo *info);

/* These do NOT wrap the function in pm_offset in an iret handler.
   You must provide an assembler interface yourself, or alloc one below.
   You may NOT LONGjmp out of an interrupt handler. */
int _go32_dpmi_get_protected_mode_interrupt_vector(int vector, _go32_dpmi_seginfo *info);
 /* puts vector in pm_selector:pm_offset. */
int _go32_dpmi_set_protected_mode_interrupt_vector(int vector, _go32_dpmi_seginfo *info);
 /* sets vector from pm_offset and pm_selector */

/********** HELPER FUNCTIONS **********/

int _go32_dpmi_chain_protected_mode_interrupt_vector(int vector, _go32_dpmi_seginfo *info);
 /* sets up wrapper that calls function in pm_offset, chaining to old
	   handler when it returns */

/* These generate assember IRET-style wrappers for functions and set up stack */
int _go32_dpmi_allocate_iret_wrapper(_go32_dpmi_seginfo *info);
 /* Put function ptr in pm_offset, call, returns wrapper entry in pm_offset. */
int _go32_dpmi_free_iret_wrapper(_go32_dpmi_seginfo *info);
 /* assumes pm_offset points to wrapper, frees it */

/* RMCB functions, automatically restructure the real-mode stack for the
   proper return type and set up correct PM stack.  The callback
   (info->pm_offset) is called as (*pmcb)(_go32_dpmi_registers *regs); */
int _go32_dpmi_allocate_real_mode_callback_retf(_go32_dpmi_seginfo *info, unsigned int regs);
 /* points callback at pm_offset, returns seg:ofs of callback addr
	   in rm_segment:rm_offset.  Do not change any fields until freed.
	   Interface is added to simulate far return */
int _go32_dpmi_allocate_real_mode_callback_iret(_go32_dpmi_seginfo *info, unsigned int regs);
 /* same, but simulates iret */
int _go32_dpmi_free_real_mode_callback(_go32_dpmi_seginfo *info);
 /* frees callback */

/* The following two variables may be used to change the default stack size
   for interrupts and rmcb wrappers to a user defined size from the default
   of 32Kbytes.  Each RMCB and chain/iret wrapper gets its own stack. */

extern unsigned int _go32_interrupt_stack_size;
extern unsigned int _go32_rmcb_stack_size;

/* Convenience functions, the return value is *bytes* */
unsigned int _go32_dpmi_remaining_physical_memory(void);
unsigned int _go32_dpmi_remaining_virtual_memory(void);

/* locks memory from a specified offset within the code/data selector */
int _go32_dpmi_lock_code( unsigned int _lockaddr, unsigned int _locksize);
int _go32_dpmi_lock_data( unsigned int _lockaddr, unsigned int _locksize);

int __djgpp_set_page_attributes(void *our_addr, unsigned int num_bytes,
           unsigned short attributes);
int __djgpp_map_physical_memory(void *our_addr, unsigned int num_bytes,
           uint64_t phys_addr);

//#endif /* !_POSIX_SOURCE */
# 5 "../../../../include/sys/fmemcpy.h" 2

void fmemcpy1(__dpmi_paddr dst, const void *src, unsigned len);
void fmemcpy2(void *dst, __dpmi_paddr src, unsigned len);
void fmemcpy12(__dpmi_paddr dst, __dpmi_paddr src, unsigned len);
# 28 "../../../../include/sys/movedata.h" 2
# 36 "../../../../include/sys/movedata.h"
/* This header is intended to be included only by other
   headers, like <go32.h> and <string.h>.  You may
   include this directly, but it will be non-portable. */

/* These lengths are in bytes, optimized for speed */
void dosmemget(unsigned long _offset, size_t _length, void *_buffer);
void dosmemput(const void *_buffer, size_t _length, unsigned long _offset);

/* The lengths here are in TRANSFERS, not bytes! */
void _dosmemgetb(unsigned long _offset, size_t _xfers, void *_buffer);
void _dosmemgetw(unsigned long _offset, size_t _xfers, void *_buffer);
void _dosmemgetl(unsigned long _offset, size_t _xfers, void *_buffer);
void _dosmemputb(const void *_buffer, size_t _xfers, unsigned long _offset);
void _dosmemputw(const void *_buffer, size_t _xfers, unsigned long _offset);
void _dosmemputl(const void *_buffer, size_t _xfers, unsigned long _offset);
# 70 "../../../../include/string.h" 2

int bcmp(const void *_ptr1, const void *_ptr2, size_t _length);
void bcopy(const void *_a, void *_b, size_t _len);
void bzero(void *ptr, size_t _len);
int ffs(int _mask);
char * index(const char *_string, int _c);
void * memccpy(void *_to, const void *_from, int _c, size_t _n);
int memicmp(const void *_s1, const void *_s2, size_t _n);
void * memmem(const void *l, size_t l_len, const void *s, size_t s_len);
char * rindex(const char *_string, int _c);
char * stpcpy(char *_dest, const char *_src);
char * stpncpy(char *_dest, const char *_src, size_t _n);
char * strdup(const char *_s);
char * strndup(const char *_s, size_t _n);
size_t strlcat(char *_dest, const char *_src, size_t _size);
size_t strlcpy(char *_dest, const char *_src, size_t _size);
char * strlwr(char *_s);
int strcasecmp(const char *_s1, const char *_s2);
int stricmp(const char *_s1, const char *_s2);
int strncasecmp(const char *_s1, const char *_s2, size_t _n);
int strnicmp(const char *_s1, const char *_s2, size_t _n);
size_t strnlen(const char *_s, size_t _n);
char * strsep(char **_stringp, const char *_delim);
char * strupr(char *_s);
# 13 "regexec.c" 2
# 1 "../../../../include/limits.h" 1
/* Copyright (C) 2012 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2003 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2001 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1998 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1995 DJ Delorie, see COPYING.DJ for details */
# 30 "../../../../include/limits.h"
  /* These are also defined by stdint.h.  */
# 74 "../../../../include/limits.h"
/* #define ARG_MAX			4096 -- depends on tb size; use sysconf */

/* #define OPEN_MAX		20 - DOS can change this */
/* #define STREAM_MAX		20 - DOS can change this */
# 91 "../../../../include/limits.h"
/* constants used in Solaris */



/* gnuc ones */
# 14 "regexec.c" 2
# 1 "../../../../include/ctype.h" 1
/* Copyright (C) 2012 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2003 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2002 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1994 DJ Delorie, see COPYING.DJ for details */
# 14 "../../../../include/ctype.h"
int isalnum(int c);
int isalpha(int c);
int iscntrl(int c);
int isdigit(int c);
int isgraph(int c);
int islower(int c);
int isprint(int c);
int ispunct(int c);
int isspace(int c);
int isupper(int c);
int isxdigit(int c);
int tolower(int c);
int toupper(int c);




int isblank(int c);




# 1 "../../../../include/inlines/ctype.ha" 1
/* Copyright (C) 2003 DJ Delorie, see COPYING.DJ for details */
# 18 "../../../../include/inlines/ctype.ha"
extern unsigned short __dj_ctype_flags[];
extern unsigned char __dj_ctype_toupper[];
extern unsigned char __dj_ctype_tolower[];
# 37 "../../../../include/ctype.h" 2
# 46 "../../../../include/ctype.h"
int _tolower(int c);
int _toupper(int c);


# 1 "../../../../include/inlines/ctype.hp" 1
/* Copyright (C) 2003 DJ Delorie, see COPYING.DJ for details */



extern unsigned char __dj_ctype_toupper[];
extern unsigned char __dj_ctype_tolower[];
# 51 "../../../../include/ctype.h" 2




int isascii(int c);
int toascii(int c);


# 1 "../../../../include/inlines/ctype.hd" 1
# 60 "../../../../include/ctype.h" 2
# 15 "regexec.c" 2
# 1 "./regex.h" 1
/* Copyright (C) 1998 DJ Delorie, see COPYING.DJ for details */


/* ========= begin header generated by ./mkh ========= */




/* === regex2.h === */
typedef off_t regoff_t;
typedef struct {
 int re_magic;
 size_t re_nsub; /* number of parenthesized subexpressions */
 const char *re_endp; /* end pointer for REG_PEND */
 struct re_guts *re_g; /* none of your business :-) */
} regex_t;
typedef struct {
 regoff_t rm_so; /* start of match */
 regoff_t rm_eo; /* end of match */
} regmatch_t;


/* === regcomp.c === */
extern int regcomp(regex_t *, const char *, int);
# 35 "./regex.h"
/* === regerror.c === */
# 55 "./regex.h"
extern size_t regerror(int, const regex_t *, char *, size_t);


/* === regexec.c === */
extern int regexec(const regex_t *, const char *, size_t, regmatch_t [], int);
# 68 "./regex.h"
/* === regfree.c === */
extern void regfree(regex_t *);




/* ========= end header generated by ./mkh ========= */
# 16 "regexec.c" 2

# 1 "utils.h" 1
/* Copyright (C) 1998 DJ Delorie, see COPYING.DJ for details */
/* utility definitions */







typedef unsigned char uch;

/* switch off assertions (if not already off) if no REDEBUG */





# 1 "../../../../include/assert.h" 1
/* Copyright (C) 2003 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1997 DJ Delorie, see COPYING.DJ for details */
# 28 "../../../../include/assert.h"
void __dj_assert(const char *,const char *,int,const char *);
# 19 "utils.h" 2

/* for old systems with bcopy() but no memmove() */
# 18 "regexec.c" 2
# 1 "regex2.h" 1
/* Copyright (C) 1998 DJ Delorie, see COPYING.DJ for details */
/*
 * First, the stuff that ends up in the outside-world include file
 = typedef off_t regoff_t;
 = typedef struct {
 = 	int re_magic;
 = 	size_t re_nsub;		// number of parenthesized subexpressions
 = 	const char *re_endp;	// end pointer for REG_PEND
 = 	struct re_guts *re_g;	// none of your business :-)
 = } regex_t;
 = typedef struct {
 = 	regoff_t rm_so;		// start of match
 = 	regoff_t rm_eo;		// end of match
 = } regmatch_t;
 */
/*
 * internals of regex_t
 */


/*
 * The internal representation is a *strip*, a sequence of
 * operators ending with an endmarker.  (Some terminology etc. is a
 * historical relic of earlier versions which used multiple strips.)
 * Certain oddities in the representation are there to permit running
 * the machinery backwards; in particular, any deviation from sequential
 * flow must be marked at both its source and its destination.  Some
 * fine points:
 *
 * - OPLUS_ and O_PLUS are *inside* the loop they create.
 * - OQUEST_ and O_QUEST are *outside* the bypass they create.
 * - OCH_ and O_CH are *outside* the multi-way branch they create, while
 *   OOR1 and OOR2 are respectively the end and the beginning of one of
 *   the branches.  Note that there is an implicit OOR2 following OCH_
 *   and an implicit OOR1 preceding O_CH.
 *
 * In state representations, an operator's bit is on to signify a state
 * immediately *preceding* "execution" of that operator.
 */
typedef long sop; /* strip operator */
typedef long sopno;






/* operators			   meaning	operand			*/
/*						(back, fwd are offsets)	*/
# 71 "regex2.h"
/*
 * Structure for [] character-set representation.  Character sets are
 * done as bit vectors, grouped 8 to a byte vector for compactness.
 * The individual set therefore has both a pointer to the byte vector
 * and a mask to pick out the relevant bit of each byte.  A hash code
 * simplifies testing whether two sets could be identical.
 *
 * This will get trickier for multicharacter collating elements.  As
 * preliminary hooks for dealing with such things, we also carry along
 * a string of multi-character elements, and decide the size of the
 * vectors at run time.
 */
typedef struct {
 uch *ptr; /* -> uch [csetsize] */
 uch mask; /* bit within array */
 uch hash; /* hash code */
 size_t smultis;
 char *multis; /* -> char[smulti]  ab\0cd\0ef\0\0 */
} cset;
/* note that CHadd and CHsub are unsafe, and CHIN doesn't yield 0/1 */







/* stuff for character categories */
typedef unsigned char cat_t;

/*
 * main compiled-expression structure
 */
struct re_guts {
 int magic;

 sop *strip; /* malloced area for strip */
 int csetsize; /* number of bits in a cset vector */
 int ncsets; /* number of csets in use */
 cset *sets; /* -> cset [ncsets] */
 uch *setbits; /* -> uch[csetsize][ncsets/CHAR_BIT] */
 int cflags; /* copy of regcomp() cflags argument */
 sopno nstates; /* = number of sops */
 sopno firststate; /* the initial OEND (normally 0) */
 sopno laststate; /* the final OEND */
 int iflags; /* internal flags */



 int nbol; /* number of ^ used */
 int neol; /* number of $ used */
 int ncategories; /* how many character categories */
 cat_t *categories; /* ->catspace[-CHAR_MIN] */
 char *must; /* match must contain this string */
 int mlen; /* length of must */
 size_t nsub; /* copy of re_nsub */
 int backrefs; /* does it use back references? */
 sopno nplus; /* how deep does it nest +s? */
 /* catspace must be last */
 cat_t catspace[1]; /* actually [NC] */
};

/* misc utilities */
# 19 "regexec.c" 2

/* macros for manipulating states, small version */
# 37 "regexec.c"
/* some abbreviations; note that some of these know variable names! */
/* do "if I'm here, I can also be there" etc without branches */



/* function names */


# 1 "engine.c" 1
/* Copyright (C) 1998 DJ Delorie, see COPYING.DJ for details */
/*
 * The matching engine and friends.  This file is #included by regexec.c
 * after suitable #defines of a variety of macros used herein, so that
 * different state representations can be used without duplicating masses
 * of code.
 */
# 32 "engine.c"
/* another structure passed up and down to avoid zillions of parameters */
struct smat {
 struct re_guts *g;
 int eflags;
 regmatch_t *pmatch; /* [nsub+1] (0 element unused) */
 char *offp; /* offsets work from here */
 char *beginp; /* start of string -- virtual NUL precedes */
 char *endp; /* end of string -- virtual NUL here */
 char *coldp; /* can be no match starting before here */
 char **lastpos; /* [nplus+1] */
 int dummy /* dummy version */;
 unsigned st; /* current states */
 unsigned fresh; /* states for a fresh start */
 unsigned tmp; /* temporary */
 unsigned empty; /* empty set of states */
};

# 1 "engine.ih" 1
/* ========= begin header generated by ./mkh ========= */




/* === engine.c === */
static int smatcher(register struct re_guts *g, char *string, size_t nmatch, regmatch_t pmatch[], int eflags);
static char *sdissect(register struct smat *m, char *start, char *stop, sopno startst, sopno stopst);
static char *sbackref(register struct smat *m, char *start, char *stop, sopno startst, sopno stopst, sopno lev);
static char *sfast(register struct smat *m, char *start, char *stop, sopno startst, sopno stopst);
static char *sslow(register struct smat *m, char *start, char *stop, sopno startst, sopno stopst);
static unsigned sstep(register struct re_guts *g, sopno start, sopno stop, register unsigned bef, int ch, register unsigned aft);
# 35 "engine.ih"
/* ========= end header generated by ./mkh ========= */
# 50 "engine.c" 2
# 61 "engine.c"
/*
 - matcher - the actual matching engine
 == static int matcher(register struct re_guts *g, char *string,  ==	size_t nmatch, regmatch_t pmatch[], int eflags);
;
 */
static int /* 0 success, REG_NOMATCH failure */
smatcher(struct re_guts *g, char *string, size_t nmatch,
    regmatch_t pmatch[], int eflags)
{
 register char *endp;
 register int i;
 struct smat mv;
 register struct smat *m = &mv;
 register char *dp;
 const register sopno gf = g->firststate+1; /* +1 for OEND */
 const register sopno gl = g->laststate;
 char *start;
 char *stop;

 /* simplify the situation where possible */
 if (g->cflags&0004)
  nmatch = 0;
 if (eflags&00004) {
  start = string + pmatch[0].rm_so;
  stop = string + pmatch[0].rm_eo;
 } else {
  start = string;
  stop = start + strlen(start);
 }
 if (stop < start)
  return(16);

 /* prescreening; this does wonders for this rather slow code */
 if (g->must != ((void*)0)) {
  for (dp = start; dp < stop; dp++)
   if (*dp == g->must[0] && stop - dp >= g->mlen &&
    memcmp(dp, g->must, (size_t)g->mlen) == 0)
    break;
  if (dp == stop) /* we didn't find g->must */
   return(1);
 }

 /* match struct setup */
 m->g = g;
 m->eflags = eflags;
 m->pmatch = ((void*)0);
 m->lastpos = ((void*)0);
 m->offp = string;
 m->beginp = start;
 m->endp = stop;
 /* nothing */;
 ((m->st) = 0);
 ((m->fresh) = 0);
 ((m->tmp) = 0);
 ((m->empty) = 0);
 ((m->empty) = 0);

 /* this loop does only one repetition except for backrefs */
 for (;;) {
  endp = sfast(m, start, stop, gf, gl);
  if (endp == ((void*)0)) { /* a miss */
   /* nothing */;
   return(1);
  }
  if (nmatch == 0 && !g->backrefs)
   break; /* no further info needed */

  /* where? */
  ((void)0);
  for (;;) {
   /* nothing */;
   endp = sslow(m, m->coldp, stop, gf, gl);
   if (endp != ((void*)0))
    break;
   ((void)0);
   m->coldp++;
  }
  if (nmatch == 1 && !g->backrefs)
   break; /* no further info needed */

  /* oh my, he wants the subexpressions... */
  if (m->pmatch == ((void*)0))
   m->pmatch = (regmatch_t *)malloc((m->g->nsub + 1) *
       sizeof(regmatch_t));
  if (m->pmatch == ((void*)0)) {
   /* nothing */;
   return(12);
  }
  for (i = 1; i <= m->g->nsub; i++)
   m->pmatch[i].rm_so = m->pmatch[i].rm_eo = -1;
  if (!g->backrefs && !(m->eflags&02000 /* force use of backref code */)) {
   /* nothing */;
   dp = sdissect(m, m->coldp, endp, gf, gl);
  } else {
   if (g->nplus > 0 && m->lastpos == ((void*)0))
    m->lastpos = (char **)malloc((g->nplus+1) *
       sizeof(char *));
   if (g->nplus > 0 && m->lastpos == ((void*)0)) {
    free(m->pmatch);
    /* nothing */;
    return(12);
   }
   /* nothing */;
   dp = sbackref(m, m->coldp, endp, gf, gl, (sopno)0);
  }
  if (dp != ((void*)0))
   break;

  /* uh-oh... we couldn't find a subexpression-level match */
  ((void)0); /* must be back references doing it */
  ((void)0);
  for (;;) {
   if (dp != ((void*)0) || endp <= m->coldp)
    break; /* defeat */
   /* nothing */;
   endp = sslow(m, m->coldp, endp-1, gf, gl);
   if (endp == ((void*)0))
    break; /* defeat */
   /* try it on a shorter possibility */






   /* nothing */;
   dp = sbackref(m, m->coldp, endp, gf, gl, (sopno)0);
  }
  ((void)0);
  if (dp != ((void*)0)) /* found a shorter one */
   break;

  /* despite initial appearances, there is no match here */
  /* nothing */;
  start = m->coldp + 1; /* recycle starting later */
  ((void)0);
 }

 /* fill in the details if requested */
 if (nmatch > 0) {
  pmatch[0].rm_so = m->coldp - m->offp;
  pmatch[0].rm_eo = endp - m->offp;
 }
 if (nmatch > 1) {
  ((void)0);
  for (i = 1; i < nmatch; i++)
   if (i <= m->g->nsub)
    pmatch[i] = m->pmatch[i];
   else {
    pmatch[i].rm_so = -1;
    pmatch[i].rm_eo = -1;
   }
 }

 if (m->pmatch != ((void*)0))
  free((char *)m->pmatch);
 if (m->lastpos != ((void*)0))
  free((char *)m->lastpos);
 /* nothing */;
 return(0);
}

/*
 - dissect - figure out what matched what, no back references
 == static char *dissect(register struct match *m, char *start,  ==	char *stop, sopno startst, sopno stopst);
;
 */
static char * /* == stop (success) always */
sdissect(struct smat *m, char *start, char *stop, sopno startst, sopno stopst)
{
 register int i;
 register sopno ss; /* start sop of current subRE */
 register sopno es; /* end sop of current subRE */
 register char *sp; /* start of string matched by it */
 register char *stp; /* string matched by it cannot pass here */
 register char *rest; /* start of rest of string */
 register char *tail; /* string unmatched by rest of RE */
 register sopno ssub; /* start sop of subsubRE */
 register sopno esub; /* end sop of subsubRE */
 register char *ssp; /* start of string matched by subsubRE */
 register char *sep; /* end of string matched by subsubRE */
 register char *oldssp; /* previous ssp */
 register char *dp;

 /* nothing */;
 sp = start;
 for (ss = startst; ss < stopst; ss = es) {
  /* identify end of subRE */
  es = ss;
  switch (((m->g->strip[es])&0x7c000000)) {
  case (9<<(26)) /* + prefix	fwd to suffix		*/:
  case (11<<(26)) /* ? prefix	fwd to suffix		*/:
   es += ((m->g->strip[es])&0x03ffffff);
   break;
  case (15<<(26)) /* begin choice	fwd to OOR2		*/:
   while (((m->g->strip[es])&0x7c000000) != (18<<(26)) /* end choice	back to OOR1		*/)
    es += ((m->g->strip[es])&0x03ffffff);
   break;
  }
  es++;

  /* figure out what it matched */
  switch (((m->g->strip[ss])&0x7c000000)) {
  case (1<<(26)) /* endmarker	-			*/:
   ((void)0);
   break;
  case (2<<(26)) /* character	unsigned char		*/:
   sp++;
   break;
  case (3<<(26)) /* left anchor	-			*/:
  case (4<<(26)) /* right anchor	-			*/:
  case (19<<(26)) /* begin word	-			*/:
  case (20<<(26)) /* end word	-			*/:
   break;
  case (5<<(26)) /* .		-			*/:
  case (6<<(26)) /* [...]	set number		*/:
   sp++;
   break;
  case (7<<(26)) /* begin \d	paren number		*/:
  case (8<<(26)) /* end \d	paren number		*/:
   ((void)0);
   break;
  /* cases where length of match is hard to find */
  case (11<<(26)) /* ? prefix	fwd to suffix		*/:
   stp = stop;
   for (;;) {
    /* how long could this one be? */
    rest = sslow(m, sp, stp, ss, es);
    ((void)0); /* it did match */
    /* could the rest match the rest? */
    tail = sslow(m, rest, stop, es, stopst);
    if (tail == stop)
     break; /* yes! */
    /* no -- try a shorter match for this one */
    stp = rest - 1;
    ((void)0); /* it did work */
   }
   ssub = ss + 1;
   esub = es - 1;
   /* did innards match? */
   if (sslow(m, sp, rest, ssub, esub) != ((void*)0)) {
    dp = sdissect(m, sp, rest, ssub, esub);
    ((void)0);
   } else /* no */
    ((void)0);
   sp = rest;
   break;
  case (9<<(26)) /* + prefix	fwd to suffix		*/:
   stp = stop;
   for (;;) {
    /* how long could this one be? */
    rest = sslow(m, sp, stp, ss, es);
    ((void)0); /* it did match */
    /* could the rest match the rest? */
    tail = sslow(m, rest, stop, es, stopst);
    if (tail == stop)
     break; /* yes! */
    /* no -- try a shorter match for this one */
    stp = rest - 1;
    ((void)0); /* it did work */
   }
   ssub = ss + 1;
   esub = es - 1;
   ssp = sp;
   oldssp = ssp;
   for (;;) { /* find last match of innards */
    sep = sslow(m, ssp, rest, ssub, esub);
    if (sep == ((void*)0) || sep == ssp)
     break; /* failed or matched null */
    oldssp = ssp; /* on to next try */
    ssp = sep;
   }
   if (sep == ((void*)0)) {
    /* last successful match */
    sep = ssp;
    ssp = oldssp;
   }
   ((void)0); /* must exhaust substring */
   ((void)0);
   dp = sdissect(m, ssp, sep, ssub, esub);
   ((void)0);
   sp = rest;
   break;
  case (15<<(26)) /* begin choice	fwd to OOR2		*/:
   stp = stop;
   for (;;) {
    /* how long could this one be? */
    rest = sslow(m, sp, stp, ss, es);
    ((void)0); /* it did match */
    /* could the rest match the rest? */
    tail = sslow(m, rest, stop, es, stopst);
    if (tail == stop)
     break; /* yes! */
    /* no -- try a shorter match for this one */
    stp = rest - 1;
    ((void)0); /* it did work */
   }
   ssub = ss + 1;
   esub = ss + ((m->g->strip[ss])&0x03ffffff) - 1;
   ((void)0);
   for (;;) { /* find first matching branch */
    if (sslow(m, sp, rest, ssub, esub) == rest)
     break; /* it matched all of it */
    /* that one missed, try next one */
    ((void)0);
    esub++;
    ((void)0);
    ssub = esub + 1;
    esub += ((m->g->strip[esub])&0x03ffffff);
    if (((m->g->strip[esub])&0x7c000000) == (17<<(26)) /* | pt. 2	fwd to OOR2 or O_CH	*/)
     esub--;
    else
     ((void)0);
   }
   dp = sdissect(m, sp, rest, ssub, esub);
   ((void)0);
   sp = rest;
   break;
  case (10<<(26)) /* + suffix	back to prefix		*/:
  case (12<<(26)) /* ? suffix	back to prefix		*/:
  case (16<<(26)) /* | pt. 1	back to OOR1 or OCH_	*/:
  case (17<<(26)) /* | pt. 2	fwd to OOR2 or O_CH	*/:
  case (18<<(26)) /* end choice	back to OOR1		*/:
   ((void)0);
   break;
  case (13<<(26)) /* (		fwd to )		*/:
   i = ((m->g->strip[ss])&0x03ffffff);
   ((void)0);
   m->pmatch[i].rm_so = sp - m->offp;
   break;
  case (14<<(26)) /* )		back to (		*/:
   i = ((m->g->strip[ss])&0x03ffffff);
   ((void)0);
   m->pmatch[i].rm_eo = sp - m->offp;
   break;
  default: /* uh oh */
   ((void)0);
   break;
  }
 }

 ((void)0);
 return(sp);
}

/*
 - backref - figure out what matched what, figuring in back references
 == static char *backref(register struct match *m, char *start,  ==	char *stop, sopno startst, sopno stopst, sopno lev);
;
 */
static char * /* == stop (success) or NULL (failure) */
sbackref(struct smat *m, char *start, char *stop, sopno startst,
    sopno stopst, sopno lev)
{
 register int i;
 register sopno ss; /* start sop of current subRE */
 register char *sp; /* start of string matched by it */
 register sopno ssub; /* start sop of subsubRE */
 register sopno esub; /* end sop of subsubRE */
 register char *ssp; /* start of string matched by subsubRE */
 register char *dp;
 register size_t len;
 register int hard;
 register sop s;
 register regoff_t offsave;
 register cset *cs;

 /* nothing */;
 sp = start;

 /* get as far as we can with easy stuff */
 hard = 0;
 for (ss = startst; !hard && ss < stopst; ss++)
  switch (((s = m->g->strip[ss])&0x7c000000)) {
  case (2<<(26)) /* character	unsigned char		*/:
   if (sp == stop || *sp++ != (char)((s)&0x03ffffff))
    return(((void*)0));
   break;
  case (5<<(26)) /* .		-			*/:
   if (sp == stop)
    return(((void*)0));
   sp++;
   break;
  case (6<<(26)) /* [...]	set number		*/:
   cs = &m->g->sets[((s)&0x03ffffff)];
   if (sp == stop || !((cs)->ptr[(uch)(*sp++)] & (cs)->mask))
    return(((void*)0));
   break;
  case (3<<(26)) /* left anchor	-			*/:
   if ( (sp == m->beginp && !(m->eflags&00001)) ||
     (sp < m->endp && *(sp-1) == '\n' &&
      (m->g->cflags&0010)) )
    { /* yes */ }
   else
    return(((void*)0));
   break;
  case (4<<(26)) /* right anchor	-			*/:
   if ( (sp == m->endp && !(m->eflags&00002)) ||
     (sp < m->endp && *sp == '\n' &&
      (m->g->cflags&0010)) )
    { /* yes */ }
   else
    return(((void*)0));
   break;
  case (19<<(26)) /* begin word	-			*/:
   if (( (sp == m->beginp && !(m->eflags&00001)) ||
     (sp < m->endp && *(sp-1) == '\n' &&
      (m->g->cflags&0010)) ||
     (sp > m->beginp &&
       !((__dj_ctype_flags[(int)(*(sp-1))+1] & 0x0001) || (*(sp-1)) == '_')) ) &&
     (sp < m->endp && ((__dj_ctype_flags[(int)(*sp)+1] & 0x0001) || (*sp) == '_')) )
    { /* yes */ }
   else
    return(((void*)0));
   break;
  case (20<<(26)) /* end word	-			*/:
   if (( (sp == m->endp && !(m->eflags&00002)) ||
     (sp < m->endp && *sp == '\n' &&
      (m->g->cflags&0010)) ||
     (sp < m->endp && !((__dj_ctype_flags[(int)(*sp)+1] & 0x0001) || (*sp) == '_')) ) &&
     (sp > m->beginp && ((__dj_ctype_flags[(int)(*(sp-1))+1] & 0x0001) || (*(sp-1)) == '_')) )
    { /* yes */ }
   else
    return(((void*)0));
   break;
  case (12<<(26)) /* ? suffix	back to prefix		*/:
   break;
  case (16<<(26)) /* | pt. 1	back to OOR1 or OCH_	*/: /* matches null but needs to skip */
   ss++;
   s = m->g->strip[ss];
   do {
    ((void)0);
    ss += ((s)&0x03ffffff);
   } while (((s = m->g->strip[ss])&0x7c000000) != (18<<(26)) /* end choice	back to OOR1		*/);
   /* note that the ss++ gets us past the O_CH */
   break;
  default: /* have to make a choice */
   hard = 1;
   break;
  }
 if (!hard) { /* that was it! */
  if (sp != stop)
   return(((void*)0));
  return(sp);
 }
 ss--; /* adjust for the for's final increment */

 /* the hard stuff */
 /* nothing */;
 s = m->g->strip[ss];
 switch (((s)&0x7c000000)) {
 case (7<<(26)) /* begin \d	paren number		*/: /* the vilest depths */
  i = ((s)&0x03ffffff);
  ((void)0);
  if (m->pmatch[i].rm_eo == -1)
   return(((void*)0));
  ((void)0);
  len = m->pmatch[i].rm_eo - m->pmatch[i].rm_so;
  ((void)0);
  if (sp > stop - len)
   return(((void*)0)); /* not enough left to match */
  ssp = m->offp + m->pmatch[i].rm_so;
  if (memcmp(sp, ssp, len) != 0)
   return(((void*)0));
  while (m->g->strip[ss] != (((8<<(26)) /* end \d	paren number		*/)|(i)))
   ss++;
  return(sbackref(m, sp+len, stop, ss+1, stopst, lev));
  break;
 case (11<<(26)) /* ? prefix	fwd to suffix		*/: /* to null or not */
  dp = sbackref(m, sp, stop, ss+1, stopst, lev);
  if (dp != ((void*)0))
   return(dp); /* not */
  return(sbackref(m, sp, stop, ss+((s)&0x03ffffff)+1, stopst, lev));
  break;
 case (9<<(26)) /* + prefix	fwd to suffix		*/:
  ((void)0);
  ((void)0);
  m->lastpos[lev+1] = sp;
  return(sbackref(m, sp, stop, ss+1, stopst, lev+1));
  break;
 case (10<<(26)) /* + suffix	back to prefix		*/:
  if (sp == m->lastpos[lev]) /* last pass matched null */
   return(sbackref(m, sp, stop, ss+1, stopst, lev-1));
  /* try another pass */
  m->lastpos[lev] = sp;
  dp = sbackref(m, sp, stop, ss-((s)&0x03ffffff)+1, stopst, lev);
  if (dp == ((void*)0))
   return(sbackref(m, sp, stop, ss+1, stopst, lev-1));
  else
   return(dp);
  break;
 case (15<<(26)) /* begin choice	fwd to OOR2		*/: /* find the right one, if any */
  ssub = ss + 1;
  esub = ss + ((s)&0x03ffffff) - 1;
  ((void)0);
  for (;;) { /* find first matching branch */
   dp = sbackref(m, sp, stop, ssub, esub, lev);
   if (dp != ((void*)0))
    return(dp);
   /* that one missed, try next one */
   if (((m->g->strip[esub])&0x7c000000) == (18<<(26)) /* end choice	back to OOR1		*/)
    return(((void*)0)); /* there is none */
   esub++;
   ((void)0);
   ssub = esub + 1;
   esub += ((m->g->strip[esub])&0x03ffffff);
   if (((m->g->strip[esub])&0x7c000000) == (17<<(26)) /* | pt. 2	fwd to OOR2 or O_CH	*/)
    esub--;
   else
    ((void)0);
  }
  break;
 case (13<<(26)) /* (		fwd to )		*/: /* must undo assignment if rest fails */
  i = ((s)&0x03ffffff);
  ((void)0);
  offsave = m->pmatch[i].rm_so;
  m->pmatch[i].rm_so = sp - m->offp;
  dp = sbackref(m, sp, stop, ss+1, stopst, lev);
  if (dp != ((void*)0))
   return(dp);
  m->pmatch[i].rm_so = offsave;
  return(((void*)0));
  break;
 case (14<<(26)) /* )		back to (		*/: /* must undo assignment if rest fails */
  i = ((s)&0x03ffffff);
  ((void)0);
  offsave = m->pmatch[i].rm_eo;
  m->pmatch[i].rm_eo = sp - m->offp;
  dp = sbackref(m, sp, stop, ss+1, stopst, lev);
  if (dp != ((void*)0))
   return(dp);
  m->pmatch[i].rm_eo = offsave;
  return(((void*)0));
  break;
 default: /* uh oh */
  ((void)0);
  break;
 }

 /* "can't happen" */
 ((void)0);
 /* NOTREACHED */
 return((char *)((void*)0)); /* dummy */
}

/*
 - fast - step through the string at top speed
 == static char *fast(register struct match *m, char *start,  ==	char *stop, sopno startst, sopno stopst);
;
 */
static char * /* where tentative match ended, or NULL */
sfast(struct smat *m, char *start, char *stop, sopno startst, sopno stopst)
{
 register unsigned st = m->st;
 register unsigned fresh = m->fresh;
 register unsigned tmp = m->tmp;
 register char *p = start;
 register int c = (start == m->beginp) ? (127 +1) /* a non-character value */ : *(start-1);
 register int lastc; /* previous c */
 register int flagch;
 register int i;
 register char *coldp; /* last p after which no match was underway */

 ((st) = 0);
 ((st) |= (unsigned)1 << (startst));
 st = sstep(m->g, startst, stopst, st, (((127 +1) /* a non-character value */+1)+3), st);
 ((fresh) = (st));
 /* nothing */;
 coldp = ((void*)0);
 for (;;) {
  /* next character */
  lastc = c;
  c = (p == m->endp) ? (127 +1) /* a non-character value */ : *p;
  if (((st) == (fresh)))
   coldp = p;

  /* is there an EOL and/or BOL between lastc and c? */
  flagch = '\0';
  i = 0;
  if ( (lastc == '\n' && m->g->cflags&0010) ||
    (lastc == (127 +1) /* a non-character value */ && !(m->eflags&00001)) ) {
   flagch = ((127 +1) /* a non-character value */+1);
   i = m->g->nbol;
  }
  if ( (c == '\n' && m->g->cflags&0010) ||
    (c == (127 +1) /* a non-character value */ && !(m->eflags&00002)) ) {
   flagch = (flagch == ((127 +1) /* a non-character value */+1)) ? (((127 +1) /* a non-character value */+1)+2) : (((127 +1) /* a non-character value */+1)+1);
   i += m->g->neol;
  }
  if (i != 0) {
   for (; i > 0; i--)
    st = sstep(m->g, startst, stopst, st, flagch, st);
   /* nothing */;
  }

  /* how about a word boundary? */
  if ( (flagch == ((127 +1) /* a non-character value */+1) || (lastc != (127 +1) /* a non-character value */ && !((__dj_ctype_flags[(int)(lastc)+1] & 0x0001) || (lastc) == '_'))) &&
     (c != (127 +1) /* a non-character value */ && ((__dj_ctype_flags[(int)(c)+1] & 0x0001) || (c) == '_')) ) {
   flagch = (((127 +1) /* a non-character value */+1)+4);
  }
  if ( (lastc != (127 +1) /* a non-character value */ && ((__dj_ctype_flags[(int)(lastc)+1] & 0x0001) || (lastc) == '_')) &&
    (flagch == (((127 +1) /* a non-character value */+1)+1) || (c != (127 +1) /* a non-character value */ && !((__dj_ctype_flags[(int)(c)+1] & 0x0001) || (c) == '_'))) ) {
   flagch = (((127 +1) /* a non-character value */+1)+5);
  }
  if (flagch == (((127 +1) /* a non-character value */+1)+4) || flagch == (((127 +1) /* a non-character value */+1)+5)) {
   st = sstep(m->g, startst, stopst, st, flagch, st);
   /* nothing */;
  }

  /* are we done? */
  if (((st) & ((unsigned)1 << (stopst))) || p == stop)
   break; /* NOTE BREAK OUT */

  /* no, we must deal with this character */
  ((tmp) = (st));
  ((st) = (fresh));
  ((void)0);
  st = sstep(m->g, startst, stopst, tmp, c, st);
  /* nothing */;
  ((void)0);
  p++;
 }

 ((void)0);
 m->coldp = coldp;
 if (((st) & ((unsigned)1 << (stopst))))
  return(p+1);
 else
  return(((void*)0));
}

/*
 - slow - step through the string more deliberately
 == static char *slow(register struct match *m, char *start,  ==	char *stop, sopno startst, sopno stopst);
;
 */
static char * /* where it ended */
sslow(struct smat *m, char *start, char *stop, sopno startst, sopno stopst)
{
 register unsigned st = m->st;
 register unsigned empty = m->empty;
 register unsigned tmp = m->tmp;
 register char *p = start;
 register int c = (start == m->beginp) ? (127 +1) /* a non-character value */ : *(start-1);
 register int lastc; /* previous c */
 register int flagch;
 register int i;
 register char *matchp; /* last p at which a match ended */

 /* nothing */;
 ((st) = 0);
 ((st) |= (unsigned)1 << (startst));
 /* nothing */;
 st = sstep(m->g, startst, stopst, st, (((127 +1) /* a non-character value */+1)+3), st);
 matchp = ((void*)0);
 for (;;) {
  /* next character */
  lastc = c;
  c = (p == m->endp) ? (127 +1) /* a non-character value */ : *p;

  /* is there an EOL and/or BOL between lastc and c? */
  flagch = '\0';
  i = 0;
  if ( (lastc == '\n' && m->g->cflags&0010) ||
    (lastc == (127 +1) /* a non-character value */ && !(m->eflags&00001)) ) {
   flagch = ((127 +1) /* a non-character value */+1);
   i = m->g->nbol;
  }
  if ( (c == '\n' && m->g->cflags&0010) ||
    (c == (127 +1) /* a non-character value */ && !(m->eflags&00002)) ) {
   flagch = (flagch == ((127 +1) /* a non-character value */+1)) ? (((127 +1) /* a non-character value */+1)+2) : (((127 +1) /* a non-character value */+1)+1);
   i += m->g->neol;
  }
  if (i != 0) {
   for (; i > 0; i--)
    st = sstep(m->g, startst, stopst, st, flagch, st);
   /* nothing */;
  }

  /* how about a word boundary? */
  if ( (flagch == ((127 +1) /* a non-character value */+1) || (lastc != (127 +1) /* a non-character value */ && !((__dj_ctype_flags[(int)(lastc)+1] & 0x0001) || (lastc) == '_'))) &&
     (c != (127 +1) /* a non-character value */ && ((__dj_ctype_flags[(int)(c)+1] & 0x0001) || (c) == '_')) ) {
   flagch = (((127 +1) /* a non-character value */+1)+4);
  }
  if ( (lastc != (127 +1) /* a non-character value */ && ((__dj_ctype_flags[(int)(lastc)+1] & 0x0001) || (lastc) == '_')) &&
    (flagch == (((127 +1) /* a non-character value */+1)+1) || (c != (127 +1) /* a non-character value */ && !((__dj_ctype_flags[(int)(c)+1] & 0x0001) || (c) == '_'))) ) {
   flagch = (((127 +1) /* a non-character value */+1)+5);
  }
  if (flagch == (((127 +1) /* a non-character value */+1)+4) || flagch == (((127 +1) /* a non-character value */+1)+5)) {
   st = sstep(m->g, startst, stopst, st, flagch, st);
   /* nothing */;
  }

  /* are we done? */
  if (((st) & ((unsigned)1 << (stopst))))
   matchp = p;
  if (((st) == (empty)) || p == stop)
   break; /* NOTE BREAK OUT */

  /* no, we must deal with this character */
  ((tmp) = (st));
  ((st) = (empty));
  ((void)0);
  st = sstep(m->g, startst, stopst, tmp, c, st);
  /* nothing */;
  ((void)0);
  p++;
 }

 return(matchp);
}


/*
 - step - map set of states reachable before char to set reachable after
 == static states step(register struct re_guts *g, sopno start, sopno stop,  ==	register states bef, int ch, register states aft);
;
 == #define	BOL	(OUT+1)
 == #define	EOL	(BOL+1)
 == #define	BOLEOL	(BOL+2)
 == #define	NOTHING	(BOL+3)
 == #define	BOW	(BOL+4)
 == #define	EOW	(BOL+5)
 == #define	CODEMAX	(BOL+5)		// highest code used
 == #define	NONCHAR(c)	((c) > CHAR_MAX)
 == #define	NNONCHAR	(CODEMAX-CHAR_MAX)
 */
static unsigned
sstep(struct re_guts *g, sopno start, sopno stop, unsigned bef, int ch, unsigned aft)
{
 register cset *cs;
 register sop s;
 register sopno pc;
 register unsigned here; /* note, macros know this name */
 register sopno look;
 register long i;

 for (pc = start, ((here) = (unsigned)1 << (pc)); pc != stop; pc++, ((here) <<= 1)) {
  s = g->strip[pc];
  switch (((s)&0x7c000000)) {
  case (1<<(26)) /* endmarker	-			*/:
   ((void)0);
   break;
  case (2<<(26)) /* character	unsigned char		*/:
   /* only characters can match */
   ((void)0);
   if (ch == (char)((s)&0x03ffffff))
    ((aft) |= ((unsigned)(bef)&(here)) << (1));
   break;
  case (3<<(26)) /* left anchor	-			*/:
   if (ch == ((127 +1) /* a non-character value */+1) || ch == (((127 +1) /* a non-character value */+1)+2))
    ((aft) |= ((unsigned)(bef)&(here)) << (1));
   break;
  case (4<<(26)) /* right anchor	-			*/:
   if (ch == (((127 +1) /* a non-character value */+1)+1) || ch == (((127 +1) /* a non-character value */+1)+2))
    ((aft) |= ((unsigned)(bef)&(here)) << (1));
   break;
  case (19<<(26)) /* begin word	-			*/:
   if (ch == (((127 +1) /* a non-character value */+1)+4))
    ((aft) |= ((unsigned)(bef)&(here)) << (1));
   break;
  case (20<<(26)) /* end word	-			*/:
   if (ch == (((127 +1) /* a non-character value */+1)+5))
    ((aft) |= ((unsigned)(bef)&(here)) << (1));
   break;
  case (5<<(26)) /* .		-			*/:
   if (!((ch) > 127))
    ((aft) |= ((unsigned)(bef)&(here)) << (1));
   break;
  case (6<<(26)) /* [...]	set number		*/:
   cs = &g->sets[((s)&0x03ffffff)];
   if (!((ch) > 127) && ((cs)->ptr[(uch)(ch)] & (cs)->mask))
    ((aft) |= ((unsigned)(bef)&(here)) << (1));
   break;
  case (7<<(26)) /* begin \d	paren number		*/: /* ignored here */
  case (8<<(26)) /* end \d	paren number		*/:
   ((aft) |= ((unsigned)(aft)&(here)) << (1));
   break;
  case (9<<(26)) /* + prefix	fwd to suffix		*/: /* forward, this is just an empty */
   ((aft) |= ((unsigned)(aft)&(here)) << (1));
   break;
  case (10<<(26)) /* + suffix	back to prefix		*/: /* both forward and back */
   ((aft) |= ((unsigned)(aft)&(here)) << (1));
   i = ((aft) & ((unsigned)here >> (((s)&0x03ffffff))));
   ((aft) |= ((unsigned)(aft)&(here)) >> (((s)&0x03ffffff)));
   if (!i && ((aft) & ((unsigned)here >> (((s)&0x03ffffff))))) {
    /* oho, must reconsider loop body */
    pc -= ((s)&0x03ffffff) + 1;
    ((here) = (unsigned)1 << (pc));
   }
   break;
  case (11<<(26)) /* ? prefix	fwd to suffix		*/: /* two branches, both forward */
   ((aft) |= ((unsigned)(aft)&(here)) << (1));
   ((aft) |= ((unsigned)(aft)&(here)) << (((s)&0x03ffffff)));
   break;
  case (12<<(26)) /* ? suffix	back to prefix		*/: /* just an empty */
   ((aft) |= ((unsigned)(aft)&(here)) << (1));
   break;
  case (13<<(26)) /* (		fwd to )		*/: /* not significant here */
  case (14<<(26)) /* )		back to (		*/:
   ((aft) |= ((unsigned)(aft)&(here)) << (1));
   break;
  case (15<<(26)) /* begin choice	fwd to OOR2		*/: /* mark the first two branches */
   ((aft) |= ((unsigned)(aft)&(here)) << (1));
   ((void)0);
   ((aft) |= ((unsigned)(aft)&(here)) << (((s)&0x03ffffff)));
   break;
  case (16<<(26)) /* | pt. 1	back to OOR1 or OCH_	*/: /* done a branch, find the O_CH */
   if (((aft) & (here))) {
    for (look = 1;
      ((s = g->strip[pc+look])&0x7c000000) != (18<<(26)) /* end choice	back to OOR1		*/;
      look += ((s)&0x03ffffff))
     ((void)0);
    ((aft) |= ((unsigned)(aft)&(here)) << (look));
   }
   break;
  case (17<<(26)) /* | pt. 2	fwd to OOR2 or O_CH	*/: /* propagate OCH_'s marking */
   ((aft) |= ((unsigned)(aft)&(here)) << (1));
   if (((g->strip[pc+((s)&0x03ffffff)])&0x7c000000) != (18<<(26)) /* end choice	back to OOR1		*/) {
    ((void)0);
    ((aft) |= ((unsigned)(aft)&(here)) << (((s)&0x03ffffff)));
   }
   break;
  case (18<<(26)) /* end choice	back to OOR1		*/: /* just empty */
   ((aft) |= ((unsigned)(aft)&(here)) << (1));
   break;
  default: /* ooooops... */
   ((void)0);
   break;
  }
 }

 return(aft);
}
# 46 "regexec.c" 2

/* now undo things */
# 68 "regexec.c"
/* macros for manipulating states, large version */
# 86 "regexec.c"
/* some abbreviations; note that some of these know variable names! */
/* do "if I'm here, I can also be there" etc without branches */



/* function names */


# 1 "engine.c" 1
/* Copyright (C) 1998 DJ Delorie, see COPYING.DJ for details */
/*
 * The matching engine and friends.  This file is #included by regexec.c
 * after suitable #defines of a variety of macros used herein, so that
 * different state representations can be used without duplicating masses
 * of code.
 */
# 32 "engine.c"
/* another structure passed up and down to avoid zillions of parameters */
struct lmat {
 struct re_guts *g;
 int eflags;
 regmatch_t *pmatch; /* [nsub+1] (0 element unused) */
 char *offp; /* offsets work from here */
 char *beginp; /* start of string -- virtual NUL precedes */
 char *endp; /* end of string -- virtual NUL here */
 char *coldp; /* can be no match starting before here */
 char **lastpos; /* [nplus+1] */
 int vn; char *space;
 char * st; /* current states */
 char * fresh; /* states for a fresh start */
 char * tmp; /* temporary */
 char * empty; /* empty set of states */
};

# 1 "engine.ih" 1
/* ========= begin header generated by ./mkh ========= */




/* === engine.c === */
static int lmatcher(register struct re_guts *g, char *string, size_t nmatch, regmatch_t pmatch[], int eflags);
static char *ldissect(register struct lmat *m, char *start, char *stop, sopno startst, sopno stopst);
static char *lbackref(register struct lmat *m, char *start, char *stop, sopno startst, sopno stopst, sopno lev);
static char *lfast(register struct lmat *m, char *start, char *stop, sopno startst, sopno stopst);
static char *lslow(register struct lmat *m, char *start, char *stop, sopno startst, sopno stopst);
static char * lstep(register struct re_guts *g, sopno start, sopno stop, register char * bef, int ch, register char * aft);
# 35 "engine.ih"
/* ========= end header generated by ./mkh ========= */
# 50 "engine.c" 2
# 61 "engine.c"
/*
 - matcher - the actual matching engine
 == static int matcher(register struct re_guts *g, char *string,  ==	size_t nmatch, regmatch_t pmatch[], int eflags);
;
 */
static int /* 0 success, REG_NOMATCH failure */
lmatcher(struct re_guts *g, char *string, size_t nmatch,
    regmatch_t pmatch[], int eflags)
{
 register char *endp;
 register int i;
 struct lmat mv;
 register struct lmat *m = &mv;
 register char *dp;
 const register sopno gf = g->firststate+1; /* +1 for OEND */
 const register sopno gl = g->laststate;
 char *start;
 char *stop;

 /* simplify the situation where possible */
 if (g->cflags&0004)
  nmatch = 0;
 if (eflags&00004) {
  start = string + pmatch[0].rm_so;
  stop = string + pmatch[0].rm_eo;
 } else {
  start = string;
  stop = start + strlen(start);
 }
 if (stop < start)
  return(16);

 /* prescreening; this does wonders for this rather slow code */
 if (g->must != ((void*)0)) {
  for (dp = start; dp < stop; dp++)
   if (*dp == g->must[0] && stop - dp >= g->mlen &&
    memcmp(dp, g->must, (size_t)g->mlen) == 0)
    break;
  if (dp == stop) /* we didn't find g->must */
   return(1);
 }

 /* match struct setup */
 m->g = g;
 m->eflags = eflags;
 m->pmatch = ((void*)0);
 m->lastpos = ((void*)0);
 m->offp = string;
 m->beginp = start;
 m->endp = stop;
 { (m)->space = (char *)malloc((4)*(m)->g->nstates); if ((m)->space == ((void*)0)) return(12); (m)->vn = 0; };
 ((m->st) = &m->space[m->vn++ * m->g->nstates]);
 ((m->fresh) = &m->space[m->vn++ * m->g->nstates]);
 ((m->tmp) = &m->space[m->vn++ * m->g->nstates]);
 ((m->empty) = &m->space[m->vn++ * m->g->nstates]);
 memset(m->empty, 0, m->g->nstates);

 /* this loop does only one repetition except for backrefs */
 for (;;) {
  endp = lfast(m, start, stop, gf, gl);
  if (endp == ((void*)0)) { /* a miss */
   { free((m)->space); };
   return(1);
  }
  if (nmatch == 0 && !g->backrefs)
   break; /* no further info needed */

  /* where? */
  ((void)0);
  for (;;) {
   /* nothing */;
   endp = lslow(m, m->coldp, stop, gf, gl);
   if (endp != ((void*)0))
    break;
   ((void)0);
   m->coldp++;
  }
  if (nmatch == 1 && !g->backrefs)
   break; /* no further info needed */

  /* oh my, he wants the subexpressions... */
  if (m->pmatch == ((void*)0))
   m->pmatch = (regmatch_t *)malloc((m->g->nsub + 1) *
       sizeof(regmatch_t));
  if (m->pmatch == ((void*)0)) {
   { free((m)->space); };
   return(12);
  }
  for (i = 1; i <= m->g->nsub; i++)
   m->pmatch[i].rm_so = m->pmatch[i].rm_eo = -1;
  if (!g->backrefs && !(m->eflags&02000 /* force use of backref code */)) {
   /* nothing */;
   dp = ldissect(m, m->coldp, endp, gf, gl);
  } else {
   if (g->nplus > 0 && m->lastpos == ((void*)0))
    m->lastpos = (char **)malloc((g->nplus+1) *
       sizeof(char *));
   if (g->nplus > 0 && m->lastpos == ((void*)0)) {
    free(m->pmatch);
    { free((m)->space); };
    return(12);
   }
   /* nothing */;
   dp = lbackref(m, m->coldp, endp, gf, gl, (sopno)0);
  }
  if (dp != ((void*)0))
   break;

  /* uh-oh... we couldn't find a subexpression-level match */
  ((void)0); /* must be back references doing it */
  ((void)0);
  for (;;) {
   if (dp != ((void*)0) || endp <= m->coldp)
    break; /* defeat */
   /* nothing */;
   endp = lslow(m, m->coldp, endp-1, gf, gl);
   if (endp == ((void*)0))
    break; /* defeat */
   /* try it on a shorter possibility */






   /* nothing */;
   dp = lbackref(m, m->coldp, endp, gf, gl, (sopno)0);
  }
  ((void)0);
  if (dp != ((void*)0)) /* found a shorter one */
   break;

  /* despite initial appearances, there is no match here */
  /* nothing */;
  start = m->coldp + 1; /* recycle starting later */
  ((void)0);
 }

 /* fill in the details if requested */
 if (nmatch > 0) {
  pmatch[0].rm_so = m->coldp - m->offp;
  pmatch[0].rm_eo = endp - m->offp;
 }
 if (nmatch > 1) {
  ((void)0);
  for (i = 1; i < nmatch; i++)
   if (i <= m->g->nsub)
    pmatch[i] = m->pmatch[i];
   else {
    pmatch[i].rm_so = -1;
    pmatch[i].rm_eo = -1;
   }
 }

 if (m->pmatch != ((void*)0))
  free((char *)m->pmatch);
 if (m->lastpos != ((void*)0))
  free((char *)m->lastpos);
 { free((m)->space); };
 return(0);
}

/*
 - dissect - figure out what matched what, no back references
 == static char *dissect(register struct match *m, char *start,  ==	char *stop, sopno startst, sopno stopst);
;
 */
static char * /* == stop (success) always */
ldissect(struct lmat *m, char *start, char *stop, sopno startst, sopno stopst)
{
 register int i;
 register sopno ss; /* start sop of current subRE */
 register sopno es; /* end sop of current subRE */
 register char *sp; /* start of string matched by it */
 register char *stp; /* string matched by it cannot pass here */
 register char *rest; /* start of rest of string */
 register char *tail; /* string unmatched by rest of RE */
 register sopno ssub; /* start sop of subsubRE */
 register sopno esub; /* end sop of subsubRE */
 register char *ssp; /* start of string matched by subsubRE */
 register char *sep; /* end of string matched by subsubRE */
 register char *oldssp; /* previous ssp */
 register char *dp;

 /* nothing */;
 sp = start;
 for (ss = startst; ss < stopst; ss = es) {
  /* identify end of subRE */
  es = ss;
  switch (((m->g->strip[es])&0x7c000000)) {
  case (9<<(26)) /* + prefix	fwd to suffix		*/:
  case (11<<(26)) /* ? prefix	fwd to suffix		*/:
   es += ((m->g->strip[es])&0x03ffffff);
   break;
  case (15<<(26)) /* begin choice	fwd to OOR2		*/:
   while (((m->g->strip[es])&0x7c000000) != (18<<(26)) /* end choice	back to OOR1		*/)
    es += ((m->g->strip[es])&0x03ffffff);
   break;
  }
  es++;

  /* figure out what it matched */
  switch (((m->g->strip[ss])&0x7c000000)) {
  case (1<<(26)) /* endmarker	-			*/:
   ((void)0);
   break;
  case (2<<(26)) /* character	unsigned char		*/:
   sp++;
   break;
  case (3<<(26)) /* left anchor	-			*/:
  case (4<<(26)) /* right anchor	-			*/:
  case (19<<(26)) /* begin word	-			*/:
  case (20<<(26)) /* end word	-			*/:
   break;
  case (5<<(26)) /* .		-			*/:
  case (6<<(26)) /* [...]	set number		*/:
   sp++;
   break;
  case (7<<(26)) /* begin \d	paren number		*/:
  case (8<<(26)) /* end \d	paren number		*/:
   ((void)0);
   break;
  /* cases where length of match is hard to find */
  case (11<<(26)) /* ? prefix	fwd to suffix		*/:
   stp = stop;
   for (;;) {
    /* how long could this one be? */
    rest = lslow(m, sp, stp, ss, es);
    ((void)0); /* it did match */
    /* could the rest match the rest? */
    tail = lslow(m, rest, stop, es, stopst);
    if (tail == stop)
     break; /* yes! */
    /* no -- try a shorter match for this one */
    stp = rest - 1;
    ((void)0); /* it did work */
   }
   ssub = ss + 1;
   esub = es - 1;
   /* did innards match? */
   if (lslow(m, sp, rest, ssub, esub) != ((void*)0)) {
    dp = ldissect(m, sp, rest, ssub, esub);
    ((void)0);
   } else /* no */
    ((void)0);
   sp = rest;
   break;
  case (9<<(26)) /* + prefix	fwd to suffix		*/:
   stp = stop;
   for (;;) {
    /* how long could this one be? */
    rest = lslow(m, sp, stp, ss, es);
    ((void)0); /* it did match */
    /* could the rest match the rest? */
    tail = lslow(m, rest, stop, es, stopst);
    if (tail == stop)
     break; /* yes! */
    /* no -- try a shorter match for this one */
    stp = rest - 1;
    ((void)0); /* it did work */
   }
   ssub = ss + 1;
   esub = es - 1;
   ssp = sp;
   oldssp = ssp;
   for (;;) { /* find last match of innards */
    sep = lslow(m, ssp, rest, ssub, esub);
    if (sep == ((void*)0) || sep == ssp)
     break; /* failed or matched null */
    oldssp = ssp; /* on to next try */
    ssp = sep;
   }
   if (sep == ((void*)0)) {
    /* last successful match */
    sep = ssp;
    ssp = oldssp;
   }
   ((void)0); /* must exhaust substring */
   ((void)0);
   dp = ldissect(m, ssp, sep, ssub, esub);
   ((void)0);
   sp = rest;
   break;
  case (15<<(26)) /* begin choice	fwd to OOR2		*/:
   stp = stop;
   for (;;) {
    /* how long could this one be? */
    rest = lslow(m, sp, stp, ss, es);
    ((void)0); /* it did match */
    /* could the rest match the rest? */
    tail = lslow(m, rest, stop, es, stopst);
    if (tail == stop)
     break; /* yes! */
    /* no -- try a shorter match for this one */
    stp = rest - 1;
    ((void)0); /* it did work */
   }
   ssub = ss + 1;
   esub = ss + ((m->g->strip[ss])&0x03ffffff) - 1;
   ((void)0);
   for (;;) { /* find first matching branch */
    if (lslow(m, sp, rest, ssub, esub) == rest)
     break; /* it matched all of it */
    /* that one missed, try next one */
    ((void)0);
    esub++;
    ((void)0);
    ssub = esub + 1;
    esub += ((m->g->strip[esub])&0x03ffffff);
    if (((m->g->strip[esub])&0x7c000000) == (17<<(26)) /* | pt. 2	fwd to OOR2 or O_CH	*/)
     esub--;
    else
     ((void)0);
   }
   dp = ldissect(m, sp, rest, ssub, esub);
   ((void)0);
   sp = rest;
   break;
  case (10<<(26)) /* + suffix	back to prefix		*/:
  case (12<<(26)) /* ? suffix	back to prefix		*/:
  case (16<<(26)) /* | pt. 1	back to OOR1 or OCH_	*/:
  case (17<<(26)) /* | pt. 2	fwd to OOR2 or O_CH	*/:
  case (18<<(26)) /* end choice	back to OOR1		*/:
   ((void)0);
   break;
  case (13<<(26)) /* (		fwd to )		*/:
   i = ((m->g->strip[ss])&0x03ffffff);
   ((void)0);
   m->pmatch[i].rm_so = sp - m->offp;
   break;
  case (14<<(26)) /* )		back to (		*/:
   i = ((m->g->strip[ss])&0x03ffffff);
   ((void)0);
   m->pmatch[i].rm_eo = sp - m->offp;
   break;
  default: /* uh oh */
   ((void)0);
   break;
  }
 }

 ((void)0);
 return(sp);
}

/*
 - backref - figure out what matched what, figuring in back references
 == static char *backref(register struct match *m, char *start,  ==	char *stop, sopno startst, sopno stopst, sopno lev);
;
 */
static char * /* == stop (success) or NULL (failure) */
lbackref(struct lmat *m, char *start, char *stop, sopno startst,
    sopno stopst, sopno lev)
{
 register int i;
 register sopno ss; /* start sop of current subRE */
 register char *sp; /* start of string matched by it */
 register sopno ssub; /* start sop of subsubRE */
 register sopno esub; /* end sop of subsubRE */
 register char *ssp; /* start of string matched by subsubRE */
 register char *dp;
 register size_t len;
 register int hard;
 register sop s;
 register regoff_t offsave;
 register cset *cs;

 /* nothing */;
 sp = start;

 /* get as far as we can with easy stuff */
 hard = 0;
 for (ss = startst; !hard && ss < stopst; ss++)
  switch (((s = m->g->strip[ss])&0x7c000000)) {
  case (2<<(26)) /* character	unsigned char		*/:
   if (sp == stop || *sp++ != (char)((s)&0x03ffffff))
    return(((void*)0));
   break;
  case (5<<(26)) /* .		-			*/:
   if (sp == stop)
    return(((void*)0));
   sp++;
   break;
  case (6<<(26)) /* [...]	set number		*/:
   cs = &m->g->sets[((s)&0x03ffffff)];
   if (sp == stop || !((cs)->ptr[(uch)(*sp++)] & (cs)->mask))
    return(((void*)0));
   break;
  case (3<<(26)) /* left anchor	-			*/:
   if ( (sp == m->beginp && !(m->eflags&00001)) ||
     (sp < m->endp && *(sp-1) == '\n' &&
      (m->g->cflags&0010)) )
    { /* yes */ }
   else
    return(((void*)0));
   break;
  case (4<<(26)) /* right anchor	-			*/:
   if ( (sp == m->endp && !(m->eflags&00002)) ||
     (sp < m->endp && *sp == '\n' &&
      (m->g->cflags&0010)) )
    { /* yes */ }
   else
    return(((void*)0));
   break;
  case (19<<(26)) /* begin word	-			*/:
   if (( (sp == m->beginp && !(m->eflags&00001)) ||
     (sp < m->endp && *(sp-1) == '\n' &&
      (m->g->cflags&0010)) ||
     (sp > m->beginp &&
       !((__dj_ctype_flags[(int)(*(sp-1))+1] & 0x0001) || (*(sp-1)) == '_')) ) &&
     (sp < m->endp && ((__dj_ctype_flags[(int)(*sp)+1] & 0x0001) || (*sp) == '_')) )
    { /* yes */ }
   else
    return(((void*)0));
   break;
  case (20<<(26)) /* end word	-			*/:
   if (( (sp == m->endp && !(m->eflags&00002)) ||
     (sp < m->endp && *sp == '\n' &&
      (m->g->cflags&0010)) ||
     (sp < m->endp && !((__dj_ctype_flags[(int)(*sp)+1] & 0x0001) || (*sp) == '_')) ) &&
     (sp > m->beginp && ((__dj_ctype_flags[(int)(*(sp-1))+1] & 0x0001) || (*(sp-1)) == '_')) )
    { /* yes */ }
   else
    return(((void*)0));
   break;
  case (12<<(26)) /* ? suffix	back to prefix		*/:
   break;
  case (16<<(26)) /* | pt. 1	back to OOR1 or OCH_	*/: /* matches null but needs to skip */
   ss++;
   s = m->g->strip[ss];
   do {
    ((void)0);
    ss += ((s)&0x03ffffff);
   } while (((s = m->g->strip[ss])&0x7c000000) != (18<<(26)) /* end choice	back to OOR1		*/);
   /* note that the ss++ gets us past the O_CH */
   break;
  default: /* have to make a choice */
   hard = 1;
   break;
  }
 if (!hard) { /* that was it! */
  if (sp != stop)
   return(((void*)0));
  return(sp);
 }
 ss--; /* adjust for the for's final increment */

 /* the hard stuff */
 /* nothing */;
 s = m->g->strip[ss];
 switch (((s)&0x7c000000)) {
 case (7<<(26)) /* begin \d	paren number		*/: /* the vilest depths */
  i = ((s)&0x03ffffff);
  ((void)0);
  if (m->pmatch[i].rm_eo == -1)
   return(((void*)0));
  ((void)0);
  len = m->pmatch[i].rm_eo - m->pmatch[i].rm_so;
  ((void)0);
  if (sp > stop - len)
   return(((void*)0)); /* not enough left to match */
  ssp = m->offp + m->pmatch[i].rm_so;
  if (memcmp(sp, ssp, len) != 0)
   return(((void*)0));
  while (m->g->strip[ss] != (((8<<(26)) /* end \d	paren number		*/)|(i)))
   ss++;
  return(lbackref(m, sp+len, stop, ss+1, stopst, lev));
  break;
 case (11<<(26)) /* ? prefix	fwd to suffix		*/: /* to null or not */
  dp = lbackref(m, sp, stop, ss+1, stopst, lev);
  if (dp != ((void*)0))
   return(dp); /* not */
  return(lbackref(m, sp, stop, ss+((s)&0x03ffffff)+1, stopst, lev));
  break;
 case (9<<(26)) /* + prefix	fwd to suffix		*/:
  ((void)0);
  ((void)0);
  m->lastpos[lev+1] = sp;
  return(lbackref(m, sp, stop, ss+1, stopst, lev+1));
  break;
 case (10<<(26)) /* + suffix	back to prefix		*/:
  if (sp == m->lastpos[lev]) /* last pass matched null */
   return(lbackref(m, sp, stop, ss+1, stopst, lev-1));
  /* try another pass */
  m->lastpos[lev] = sp;
  dp = lbackref(m, sp, stop, ss-((s)&0x03ffffff)+1, stopst, lev);
  if (dp == ((void*)0))
   return(lbackref(m, sp, stop, ss+1, stopst, lev-1));
  else
   return(dp);
  break;
 case (15<<(26)) /* begin choice	fwd to OOR2		*/: /* find the right one, if any */
  ssub = ss + 1;
  esub = ss + ((s)&0x03ffffff) - 1;
  ((void)0);
  for (;;) { /* find first matching branch */
   dp = lbackref(m, sp, stop, ssub, esub, lev);
   if (dp != ((void*)0))
    return(dp);
   /* that one missed, try next one */
   if (((m->g->strip[esub])&0x7c000000) == (18<<(26)) /* end choice	back to OOR1		*/)
    return(((void*)0)); /* there is none */
   esub++;
   ((void)0);
   ssub = esub + 1;
   esub += ((m->g->strip[esub])&0x03ffffff);
   if (((m->g->strip[esub])&0x7c000000) == (17<<(26)) /* | pt. 2	fwd to OOR2 or O_CH	*/)
    esub--;
   else
    ((void)0);
  }
  break;
 case (13<<(26)) /* (		fwd to )		*/: /* must undo assignment if rest fails */
  i = ((s)&0x03ffffff);
  ((void)0);
  offsave = m->pmatch[i].rm_so;
  m->pmatch[i].rm_so = sp - m->offp;
  dp = lbackref(m, sp, stop, ss+1, stopst, lev);
  if (dp != ((void*)0))
   return(dp);
  m->pmatch[i].rm_so = offsave;
  return(((void*)0));
  break;
 case (14<<(26)) /* )		back to (		*/: /* must undo assignment if rest fails */
  i = ((s)&0x03ffffff);
  ((void)0);
  offsave = m->pmatch[i].rm_eo;
  m->pmatch[i].rm_eo = sp - m->offp;
  dp = lbackref(m, sp, stop, ss+1, stopst, lev);
  if (dp != ((void*)0))
   return(dp);
  m->pmatch[i].rm_eo = offsave;
  return(((void*)0));
  break;
 default: /* uh oh */
  ((void)0);
  break;
 }

 /* "can't happen" */
 ((void)0);
 /* NOTREACHED */
 return((char *)((void*)0)); /* dummy */
}

/*
 - fast - step through the string at top speed
 == static char *fast(register struct match *m, char *start,  ==	char *stop, sopno startst, sopno stopst);
;
 */
static char * /* where tentative match ended, or NULL */
lfast(struct lmat *m, char *start, char *stop, sopno startst, sopno stopst)
{
 register char * st = m->st;
 register char * fresh = m->fresh;
 register char * tmp = m->tmp;
 register char *p = start;
 register int c = (start == m->beginp) ? (127 +1) /* a non-character value */ : *(start-1);
 register int lastc; /* previous c */
 register int flagch;
 register int i;
 register char *coldp; /* last p after which no match was underway */

 memset(st, 0, m->g->nstates);
 ((st)[startst] = 1);
 st = lstep(m->g, startst, stopst, st, (((127 +1) /* a non-character value */+1)+3), st);
 memcpy(fresh, st, m->g->nstates);
 /* nothing */;
 coldp = ((void*)0);
 for (;;) {
  /* next character */
  lastc = c;
  c = (p == m->endp) ? (127 +1) /* a non-character value */ : *p;
  if ((memcmp(st, fresh, m->g->nstates) == 0))
   coldp = p;

  /* is there an EOL and/or BOL between lastc and c? */
  flagch = '\0';
  i = 0;
  if ( (lastc == '\n' && m->g->cflags&0010) ||
    (lastc == (127 +1) /* a non-character value */ && !(m->eflags&00001)) ) {
   flagch = ((127 +1) /* a non-character value */+1);
   i = m->g->nbol;
  }
  if ( (c == '\n' && m->g->cflags&0010) ||
    (c == (127 +1) /* a non-character value */ && !(m->eflags&00002)) ) {
   flagch = (flagch == ((127 +1) /* a non-character value */+1)) ? (((127 +1) /* a non-character value */+1)+2) : (((127 +1) /* a non-character value */+1)+1);
   i += m->g->neol;
  }
  if (i != 0) {
   for (; i > 0; i--)
    st = lstep(m->g, startst, stopst, st, flagch, st);
   /* nothing */;
  }

  /* how about a word boundary? */
  if ( (flagch == ((127 +1) /* a non-character value */+1) || (lastc != (127 +1) /* a non-character value */ && !((__dj_ctype_flags[(int)(lastc)+1] & 0x0001) || (lastc) == '_'))) &&
     (c != (127 +1) /* a non-character value */ && ((__dj_ctype_flags[(int)(c)+1] & 0x0001) || (c) == '_')) ) {
   flagch = (((127 +1) /* a non-character value */+1)+4);
  }
  if ( (lastc != (127 +1) /* a non-character value */ && ((__dj_ctype_flags[(int)(lastc)+1] & 0x0001) || (lastc) == '_')) &&
    (flagch == (((127 +1) /* a non-character value */+1)+1) || (c != (127 +1) /* a non-character value */ && !((__dj_ctype_flags[(int)(c)+1] & 0x0001) || (c) == '_'))) ) {
   flagch = (((127 +1) /* a non-character value */+1)+5);
  }
  if (flagch == (((127 +1) /* a non-character value */+1)+4) || flagch == (((127 +1) /* a non-character value */+1)+5)) {
   st = lstep(m->g, startst, stopst, st, flagch, st);
   /* nothing */;
  }

  /* are we done? */
  if (((st)[stopst]) || p == stop)
   break; /* NOTE BREAK OUT */

  /* no, we must deal with this character */
  memcpy(tmp, st, m->g->nstates);
  memcpy(st, fresh, m->g->nstates);
  ((void)0);
  st = lstep(m->g, startst, stopst, tmp, c, st);
  /* nothing */;
  ((void)0);
  p++;
 }

 ((void)0);
 m->coldp = coldp;
 if (((st)[stopst]))
  return(p+1);
 else
  return(((void*)0));
}

/*
 - slow - step through the string more deliberately
 == static char *slow(register struct match *m, char *start,  ==	char *stop, sopno startst, sopno stopst);
;
 */
static char * /* where it ended */
lslow(struct lmat *m, char *start, char *stop, sopno startst, sopno stopst)
{
 register char * st = m->st;
 register char * empty = m->empty;
 register char * tmp = m->tmp;
 register char *p = start;
 register int c = (start == m->beginp) ? (127 +1) /* a non-character value */ : *(start-1);
 register int lastc; /* previous c */
 register int flagch;
 register int i;
 register char *matchp; /* last p at which a match ended */

 /* nothing */;
 memset(st, 0, m->g->nstates);
 ((st)[startst] = 1);
 /* nothing */;
 st = lstep(m->g, startst, stopst, st, (((127 +1) /* a non-character value */+1)+3), st);
 matchp = ((void*)0);
 for (;;) {
  /* next character */
  lastc = c;
  c = (p == m->endp) ? (127 +1) /* a non-character value */ : *p;

  /* is there an EOL and/or BOL between lastc and c? */
  flagch = '\0';
  i = 0;
  if ( (lastc == '\n' && m->g->cflags&0010) ||
    (lastc == (127 +1) /* a non-character value */ && !(m->eflags&00001)) ) {
   flagch = ((127 +1) /* a non-character value */+1);
   i = m->g->nbol;
  }
  if ( (c == '\n' && m->g->cflags&0010) ||
    (c == (127 +1) /* a non-character value */ && !(m->eflags&00002)) ) {
   flagch = (flagch == ((127 +1) /* a non-character value */+1)) ? (((127 +1) /* a non-character value */+1)+2) : (((127 +1) /* a non-character value */+1)+1);
   i += m->g->neol;
  }
  if (i != 0) {
   for (; i > 0; i--)
    st = lstep(m->g, startst, stopst, st, flagch, st);
   /* nothing */;
  }

  /* how about a word boundary? */
  if ( (flagch == ((127 +1) /* a non-character value */+1) || (lastc != (127 +1) /* a non-character value */ && !((__dj_ctype_flags[(int)(lastc)+1] & 0x0001) || (lastc) == '_'))) &&
     (c != (127 +1) /* a non-character value */ && ((__dj_ctype_flags[(int)(c)+1] & 0x0001) || (c) == '_')) ) {
   flagch = (((127 +1) /* a non-character value */+1)+4);
  }
  if ( (lastc != (127 +1) /* a non-character value */ && ((__dj_ctype_flags[(int)(lastc)+1] & 0x0001) || (lastc) == '_')) &&
    (flagch == (((127 +1) /* a non-character value */+1)+1) || (c != (127 +1) /* a non-character value */ && !((__dj_ctype_flags[(int)(c)+1] & 0x0001) || (c) == '_'))) ) {
   flagch = (((127 +1) /* a non-character value */+1)+5);
  }
  if (flagch == (((127 +1) /* a non-character value */+1)+4) || flagch == (((127 +1) /* a non-character value */+1)+5)) {
   st = lstep(m->g, startst, stopst, st, flagch, st);
   /* nothing */;
  }

  /* are we done? */
  if (((st)[stopst]))
   matchp = p;
  if ((memcmp(st, empty, m->g->nstates) == 0) || p == stop)
   break; /* NOTE BREAK OUT */

  /* no, we must deal with this character */
  memcpy(tmp, st, m->g->nstates);
  memcpy(st, empty, m->g->nstates);
  ((void)0);
  st = lstep(m->g, startst, stopst, tmp, c, st);
  /* nothing */;
  ((void)0);
  p++;
 }

 return(matchp);
}


/*
 - step - map set of states reachable before char to set reachable after
 == static states step(register struct re_guts *g, sopno start, sopno stop,  ==	register states bef, int ch, register states aft);
;
 == #define	BOL	(OUT+1)
 == #define	EOL	(BOL+1)
 == #define	BOLEOL	(BOL+2)
 == #define	NOTHING	(BOL+3)
 == #define	BOW	(BOL+4)
 == #define	EOW	(BOL+5)
 == #define	CODEMAX	(BOL+5)		// highest code used
 == #define	NONCHAR(c)	((c) > CHAR_MAX)
 == #define	NNONCHAR	(CODEMAX-CHAR_MAX)
 */
static char *
lstep(struct re_guts *g, sopno start, sopno stop, char * bef, int ch, char * aft)
{
 register cset *cs;
 register sop s;
 register sopno pc;
 register int here; /* note, macros know this name */
 register sopno look;
 register long i;

 for (pc = start, ((here) = (pc)); pc != stop; pc++, ((here)++)) {
  s = g->strip[pc];
  switch (((s)&0x7c000000)) {
  case (1<<(26)) /* endmarker	-			*/:
   ((void)0);
   break;
  case (2<<(26)) /* character	unsigned char		*/:
   /* only characters can match */
   ((void)0);
   if (ch == (char)((s)&0x03ffffff))
    ((aft)[here+(1)] |= (bef)[here]);
   break;
  case (3<<(26)) /* left anchor	-			*/:
   if (ch == ((127 +1) /* a non-character value */+1) || ch == (((127 +1) /* a non-character value */+1)+2))
    ((aft)[here+(1)] |= (bef)[here]);
   break;
  case (4<<(26)) /* right anchor	-			*/:
   if (ch == (((127 +1) /* a non-character value */+1)+1) || ch == (((127 +1) /* a non-character value */+1)+2))
    ((aft)[here+(1)] |= (bef)[here]);
   break;
  case (19<<(26)) /* begin word	-			*/:
   if (ch == (((127 +1) /* a non-character value */+1)+4))
    ((aft)[here+(1)] |= (bef)[here]);
   break;
  case (20<<(26)) /* end word	-			*/:
   if (ch == (((127 +1) /* a non-character value */+1)+5))
    ((aft)[here+(1)] |= (bef)[here]);
   break;
  case (5<<(26)) /* .		-			*/:
   if (!((ch) > 127))
    ((aft)[here+(1)] |= (bef)[here]);
   break;
  case (6<<(26)) /* [...]	set number		*/:
   cs = &g->sets[((s)&0x03ffffff)];
   if (!((ch) > 127) && ((cs)->ptr[(uch)(ch)] & (cs)->mask))
    ((aft)[here+(1)] |= (bef)[here]);
   break;
  case (7<<(26)) /* begin \d	paren number		*/: /* ignored here */
  case (8<<(26)) /* end \d	paren number		*/:
   ((aft)[here+(1)] |= (aft)[here]);
   break;
  case (9<<(26)) /* + prefix	fwd to suffix		*/: /* forward, this is just an empty */
   ((aft)[here+(1)] |= (aft)[here]);
   break;
  case (10<<(26)) /* + suffix	back to prefix		*/: /* both forward and back */
   ((aft)[here+(1)] |= (aft)[here]);
   i = ((aft)[here - (((s)&0x03ffffff))]);
   ((aft)[here-(((s)&0x03ffffff))] |= (aft)[here]);
   if (!i && ((aft)[here - (((s)&0x03ffffff))])) {
    /* oho, must reconsider loop body */
    pc -= ((s)&0x03ffffff) + 1;
    ((here) = (pc));
   }
   break;
  case (11<<(26)) /* ? prefix	fwd to suffix		*/: /* two branches, both forward */
   ((aft)[here+(1)] |= (aft)[here]);
   ((aft)[here+(((s)&0x03ffffff))] |= (aft)[here]);
   break;
  case (12<<(26)) /* ? suffix	back to prefix		*/: /* just an empty */
   ((aft)[here+(1)] |= (aft)[here]);
   break;
  case (13<<(26)) /* (		fwd to )		*/: /* not significant here */
  case (14<<(26)) /* )		back to (		*/:
   ((aft)[here+(1)] |= (aft)[here]);
   break;
  case (15<<(26)) /* begin choice	fwd to OOR2		*/: /* mark the first two branches */
   ((aft)[here+(1)] |= (aft)[here]);
   ((void)0);
   ((aft)[here+(((s)&0x03ffffff))] |= (aft)[here]);
   break;
  case (16<<(26)) /* | pt. 1	back to OOR1 or OCH_	*/: /* done a branch, find the O_CH */
   if (((aft)[here])) {
    for (look = 1;
      ((s = g->strip[pc+look])&0x7c000000) != (18<<(26)) /* end choice	back to OOR1		*/;
      look += ((s)&0x03ffffff))
     ((void)0);
    ((aft)[here+(look)] |= (aft)[here]);
   }
   break;
  case (17<<(26)) /* | pt. 2	fwd to OOR2 or O_CH	*/: /* propagate OCH_'s marking */
   ((aft)[here+(1)] |= (aft)[here]);
   if (((g->strip[pc+((s)&0x03ffffff)])&0x7c000000) != (18<<(26)) /* end choice	back to OOR1		*/) {
    ((void)0);
    ((aft)[here+(((s)&0x03ffffff))] |= (aft)[here]);
   }
   break;
  case (18<<(26)) /* end choice	back to OOR1		*/: /* just empty */
   ((aft)[here+(1)] |= (aft)[here]);
   break;
  default: /* ooooops... */
   ((void)0);
   break;
  }
 }

 return(aft);
}
# 95 "regexec.c" 2

/*
 - regexec - interface for matching
 = extern int regexec(const regex_t *, const char *, size_t,  =					regmatch_t [], int);
;
 = #define	REG_NOTBOL	00001
 = #define	REG_NOTEOL	00002
 = #define	REG_STARTEND	00004
 = #define	REG_TRACE	00400	// tracing of execution
 = #define	REG_LARGE	01000	// force large representation
 = #define	REG_BACKR	02000	// force use of backref code
 *
 * We put this here so we can exploit knowledge of the state representation
 * when choosing which matcher to call.  Also, by this point the matchers
 * have been prototyped.
 */
int /* 0 success, REG_NOMATCH failure */
regexec(const regex_t *preg, const char *string, size_t nmatch,
    regmatch_t pmatch[], int eflags)
{
 register struct re_guts *g = preg->re_g;






 if (preg->re_magic != ((('r'^0200)<<8) | 'e') || g->magic != ((('R'^0200)<<8)|'E'))
  return(2);
 ((void)0);
 if (g->iflags&04 /* something wrong */) /* backstop for no-debug case */
  return(2);
 eflags = ((eflags)&(00001|00002|00004));

 if (g->nstates <= 8*sizeof(unsigned /* for later use in regexec() decision */) && !(eflags&01000 /* force large representation */))
  return(smatcher(g, (char *)string, nmatch, pmatch, eflags));
 else
  return(lmatcher(g, (char *)string, nmatch, pmatch, eflags));
}
