# 0 "_hash2v.c"
# 0 "<built-in>"
# 0 "<command-line>"
# 1 "_hash2v.c"
/* Copyright (C) 2015 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2007 DJ Delorie, see COPYING.DJ for details */
/*
 * File _hash2v.c.
 *
 * From <http://burtleburtle.net/bob/hash/doobs.html>.
 * Two lines from below quoted:
 * "By Bob Jenkins, 1996.  bob_jenkins@burtleburtle.net.  You may use this
 * code any way you wish, private, educational, or commercial.  It's free."
 *
 * Modifications by Martin Str@"omberg <ams@ludd.ltu.se>:
 *   - unnecessary code removed
 *   - ub1 and ub4 typedefs converted into unsigned char and unsigned long
 *   - proper C89 parameters
 *   - detect length while calculating
 *   - fixed initial value (0)
 *   - generate a second hash value (b)
 *   - #include**s added
 *
 */

# 1 "../../../../include/search.h" 1
/* Copyright (C) 2012 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2003 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1999 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1995 DJ Delorie, see COPYING.DJ for details */
# 14 "../../../../include/search.h"
# 1 "../../../../include/sys/djtypes.h" 1
/* Copyright (C) 2011 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2003 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2002 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2001 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2000 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1999 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1998 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1994 DJ Delorie, see COPYING.DJ for details */
# 23 "../../../../include/sys/djtypes.h"
/* For GCC 3.00 or later we use its builtin va_list.                       */
# 34 "../../../../include/sys/djtypes.h"
/* but remains a typedef in C */





/* Define internal type to be used for avoiding strict
   aliasing warnings */

typedef short __attribute__((__may_alias__)) __dj_short_a;
typedef int __attribute__((__may_alias__)) __dj_int_a;
typedef long __attribute__((__may_alias__)) __dj_long_a;
typedef long long __attribute__((__may_alias__)) __dj_long_long_a;
typedef unsigned short __attribute__((__may_alias__)) __dj_unsigned_short_a;
typedef unsigned int __attribute__((__may_alias__)) __dj_unsigned_int_a;
typedef unsigned long __attribute__((__may_alias__)) __dj_unsigned_long_a;
typedef unsigned long long __attribute__((__may_alias__)) __dj_unsigned_long_long_a;
typedef float __attribute__((__may_alias__)) __dj_float_a;
typedef double __attribute__((__may_alias__)) __dj_double_a;
typedef long double __attribute__((__may_alias__)) __dj_long_double_a;
# 15 "../../../../include/search.h" 2


typedef long unsigned int size_t;
# 28 "../../../../include/search.h"
/* ACTION type for hsearch(). */
typedef enum {
  FIND,
  ENTER
} ACTION;

/* ENTRY type for hsearch(). */
typedef struct entry {
  char *key;
  void *data;
} ENTRY;


int hcreate(size_t _nel);
void hdestroy(void);
ENTRY * hsearch(ENTRY _item, ACTION _action);
void * lfind(const void *_key, void *_base, size_t *_nelp, size_t _width,
       int(*_compar)(const void *, const void *));
void * lsearch(const void *_key, void *_base, size_t *_nelp, size_t _width,
  int(*_compar)(const void *, const void *));

typedef enum { preorder, postorder, endorder, leaf } VISIT;
void *tdelete(const void *, void **, int(*)(const void *, const void *));
void *tfind(const void *, void *const *, int(*)(const void *, const void *));
void *tsearch(const void *, void **, int (*)(const void *, const void *));
void twalk(const void *, void (*)(const void *, VISIT, int));



/* qelem type for insque and remque. */
typedef struct qelem {
  struct qelem *q_forw;
  struct qelem *q_back;
  char q_data[0];
} qelem;

unsigned long _hash2v(const unsigned char *s, unsigned long *v2);
void insque(struct qelem *_elem, struct qelem *_pred);
void remque(struct qelem *_elem);
# 23 "_hash2v.c" 2

/*
--------------------------------------------------------------------
mix -- mix 3 32-bit values reversibly.
For every delta with one or two bits set, and the deltas of all three
  high bits or all three low bits, whether the original value of a,b,c
  is almost all zero or is uniformly distributed,
* If mix() is run forward or backward, at least 32 bits in a,b,c
  have at least 1/4 probability of changing.
* If mix() is run forward, every bit of c will change between 1/3 and
  2/3 of the time.  (Well, 22/100 and 78/100 for some 2-bit deltas.)
mix() was built out of 36 single-cycle latency instructions in a
  structure that could supported 2x parallelism, like so:
      a -= b;
      a -= c; x = (c>>13);
      b -= c; a ^= x;
      b -= a; x = (a<<8);
      c -= a; b ^= x;
      c -= b; x = (b>>13);
      ...
  Unfortunately, superscalar Pentiums and Sparcs can't take advantage
  of that parallelism.  They've also turned some of those single-cycle
  latency instructions into multi-cycle latency instructions.  Still,
  this is the fastest good hash I could find.  There were about 2^^68
  to choose from.  I only looked at a billion or so.
--------------------------------------------------------------------
*/
# 63 "_hash2v.c"
unsigned long _hash2v( const unsigned char *k, unsigned long *v2 )
{
  int cont, which;
  unsigned long a, b, c, len;

  /* Set up the internal state */
  len = 0;
  a = b = 0x9e3779b9; /* the golden ratio; an arbitrary value */
  c = 0; /* No previous hash value. */

   /*---------------------------------------- handle most of the key */
  cont = 1;
  while( cont )
  {
    for( which = 0; which < 12; which++ )
    {
      if( !k[which] )
      {
 cont = 0;
 break;
      }
    }
    if( cont )
    {
      a += (k[0] +((unsigned long)k[1]<<8) +((unsigned long)k[2]<<16)
     +((unsigned long)k[3]<<24));
      b += (k[4] +((unsigned long)k[5]<<8) +((unsigned long)k[6]<<16)
     +((unsigned long)k[7]<<24));
      c += (k[8] +((unsigned long)k[9]<<8) +((unsigned long)k[10]<<16)
     +((unsigned long)k[11]<<24));
      { a -= b; a -= c; a ^= (c>>13); b -= c; b -= a; b ^= (a<<8); c -= a; c -= b; c ^= (b>>13); a -= b; a -= c; a ^= (c>>12); b -= c; b -= a; b ^= (a<<16); c -= a; c -= b; c ^= (b>>5); a -= b; a -= c; a ^= (c>>3); b -= c; b -= a; b ^= (a<<10); c -= a; c -= b; c ^= (b>>15); };
      k += 12; len += 12;
    }
  }

  len += which;

   /*------------------------------------- handle the last 11 bytes */
  c += len;
  switch(which) /* all the case statements fall through */
  {
  case 11: c+=((unsigned long)k[10]<<24);
  case 10: c+=((unsigned long)k[9]<<16);
  case 9 : c+=((unsigned long)k[8]<<8);
    /* the first byte of c is reserved for the length */
  case 8 : b+=((unsigned long)k[7]<<24);
  case 7 : b+=((unsigned long)k[6]<<16);
  case 6 : b+=((unsigned long)k[5]<<8);
  case 5 : b+=k[4];
  case 4 : a+=((unsigned long)k[3]<<24);
  case 3 : a+=((unsigned long)k[2]<<16);
  case 2 : a+=((unsigned long)k[1]<<8);
  case 1 : a+=k[0];
    /* case 0: nothing left to add */
  }
  { a -= b; a -= c; a ^= (c>>13); b -= c; b -= a; b ^= (a<<8); c -= a; c -= b; c ^= (b>>13); a -= b; a -= c; a ^= (c>>12); b -= c; b -= a; b ^= (a<<16); c -= a; c -= b; c ^= (b>>5); a -= b; a -= c; a ^= (c>>3); b -= c; b -= a; b ^= (a<<10); c -= a; c -= b; c ^= (b>>15); };
  /*-------------------------------------------- report the result */

  *v2 = b;
  return c;
}
